/***************************************************************************
 *   Copyright (C) 2009 by Andreas Lindenau   *
 *   DL4JAL@darc.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include <QtGui>
#include "avfo.h"

#include <QWidget>
#include <QTextStream>
#include <QCloseEvent>
#include <QFileDialog>
#include <QMessageBox>
#include <QString>
#include <QFileDialog>
#include <QFile>
#include <QTextStream>
#include <QDataStream>
#include <qglobal.h>
#include <QInputDialog>

avfo::avfo()
{
  version = "V1.05";
  verdatum = " vom 18.12.2012";
///////////////////////////////////////////////////////////////////////////////
//Schnittstelle zum NWT7 erzeugen erzeugen fuer alle Widgets
//  picmodem = new QextSerialPort("/dev/ttyS0");
//  delete picmodem;
  picmodem = new Modem();
//  picmodem->opentty(weichen.str_tty);
  QObject::connect( picmodem, SIGNAL(setTtyText(QString)), this, SLOT(setAText(QString)));
//  bttyOpen = picmodem->opentty(weichen.str_tty);
///////////////////////////////////////////////////////////////////////////////

  awidget = new QTabWidget();
//  awidget->setTabPosition(QTabWidget::West);
  setCentralWidget(awidget);
  grunddaten = new QWidget();
  awidget->addTab(grunddaten, tr("Grunddaten","TabWindow"));
  dds = new QGroupBox(tr("DDS","GroupBox"), grunddaten);
  dds->setGeometry(10,20,220,200);
  edddstakt = new QLineEdit(dds);
  edddstakt->setGeometry(70,20,120,20);
  labelddstakt = new QLabel(tr("Takt (Hz)","DDS"), dds);
  labelddstakt->setGeometry(10,20,60,20);
  ad9833 = new QRadioButton(dds);
  ad9833->setText(tr("AD9833/AD9834"));
  ad9833->setGeometry(10,50,170,20);
  ad9833->setChecked(TRUE);
  ad9850 = new QRadioButton(dds);
  ad9850->setText(tr("AD9850/51"));
  ad9850->setGeometry(10,70,170,20);
  ad9851 = new QRadioButton(dds);
  ad9851->setText(tr("AD9851 mit PLL x 6"));
  ad9851->setGeometry(10,90,170,20);
  ad9951_1 = new QRadioButton(dds);
  ad9951_1->setText(tr("AD9951 mit PLL x 4"));
  ad9951_1->setGeometry(10,110,170,20);
  ad9951_2 = new QRadioButton(dds);
  ad9951_2->setText(tr("AD9951 mit PLL x 5"));
  ad9951_2->setGeometry(10,130,170,20);
  ad9951_3 = new QRadioButton(dds);
  ad9951_3->setText(tr("AD9951 mit PLL x 20"));
  ad9951_3->setGeometry(10,150,170,20);
  ad9951_4 = new QRadioButton(dds);
  ad9951_4->setText(tr("AD9951 ohne PLL"));
  ad9951_4->setGeometry(10,170,170,20);
  zf = new QGroupBox(tr("ZF (Hz) / S-Meter X/Y","GroupBox ZF"), grunddaten);
  zf->setGeometry(240,20,220,230);
  zfcw = new QLineEdit(zf);
  zfcw->setGeometry(80,20,120,20);
  labelzfcw = new QLabel(tr("CW (Hz)","ZF"), zf);
  labelzfcw->setGeometry(10,20,60,20);
  labelzfcw->setAlignment(Qt::AlignRight);
  zfcwr = new QLineEdit(zf);
  zfcwr->setGeometry(80,45,120,20);
  labelzfcwr = new QLabel(tr("CWr (Hz)","ZF"), zf);
  labelzfcwr->setGeometry(10,45,60,20);
  labelzfcwr->setAlignment(Qt::AlignRight);
  zflsb = new QLineEdit(zf);
  zflsb->setGeometry(80,70,120,20);
  labelzflsb = new QLabel(tr("LSB (Hz)","ZF"), zf);
  labelzflsb->setGeometry(10,70,60,20);
  labelzflsb->setAlignment(Qt::AlignRight);
  zfusb = new QLineEdit(zf);
  zfusb->setGeometry(80,95,120,20);
  labelzfusb = new QLabel(tr("USB (Hz)","ZF"), zf);
  labelzfusb->setGeometry(10,95,60,20);
  labelzfusb->setAlignment(Qt::AlignRight);
  zfdig = new QLineEdit(zf);
  zfdig->setGeometry(80,120,120,20);
  labelzfdig = new QLabel(tr("DIG (Hz)","ZF"), zf);
  labelzfdig->setGeometry(10,120,60,20);
  labelzfdig->setAlignment(Qt::AlignRight);
  zfdigr = new QLineEdit(zf);
  zfdigr->setGeometry(80,145,120,20);
  labelzfdigr = new QLabel(tr("DIGr (Hz)","ZF"), zf);
  labelzfdigr->setGeometry(10,145,60,20);
  labelzfdigr->setAlignment(Qt::AlignRight);
  smx = new QLabel("", zf);
  smx->setGeometry(100,170,110,20);
  labelsmx = new QLabel(tr("S-Meter X","ZF"), zf);
  labelsmx->setGeometry(10,170,80,20);
  labelsmx->setAlignment(Qt::AlignRight);
  smy = new QLabel("", zf);
  smy->setGeometry(100,195,110,20);
  labelsmy = new QLabel(tr("S-Meter Y","ZF"), zf);
  labelsmy->setGeometry(10,195,80,20);
  labelsmy->setAlignment(Qt::AlignRight);
  
  diverses = new QGroupBox(tr("Diverse Einstellungen","GroupBox divers"), grunddaten);
  diverses->setGeometry(470,20,370,280);
  c1hz = new QCheckBox(diverses);
  c1hz->setText(tr("Anzeige/Abstimmung 1Hz","CheckBox divers"));
  c1hz->setChecked(FALSE);
  c1hz->setGeometry(10,20,280,20);
  dauerlicht = new QCheckBox(diverses);
  QObject::connect( dauerlicht, SIGNAL( stateChanged (int)), this, SLOT(setdauerlicht(int)));
  dauerlicht->setText(tr("Hintergrund-Led dauerhaft","CheckBox divers"));
  dauerlicht->setChecked(FALSE);
  dauerlicht->setGeometry(10,40,280,20);
  autolicht = new QCheckBox(diverses);
  QObject::connect( autolicht, SIGNAL( stateChanged (int)), this, SLOT(setautolicht(int)));
  autolicht->setText(tr("Hintergrund-Led automatisch","CheckBox divers"));
  autolicht->setChecked(FALSE);
  autolicht->setGeometry(10,60,280,20);
  smeter = new QCheckBox(diverses);
  smeter->setText(tr("S-Meter aktivieren","CheckBox divers"));
  smeter->setChecked(FALSE);
  smeter->setGeometry(10,80,280,20);
  keyer = new QCheckBox(diverses);
  keyer->setText(tr("Keyer aktivieren","CheckBox divers"));
  keyer->setChecked(FALSE);
  keyer->setGeometry(10,100,250,20);
  sendenohnezf = new QCheckBox(diverses);
  sendenohnezf->setText(tr("ZF auch beim Senden aktivieren (CW,CWr)","CheckBox divers"));
  sendenohnezf->setChecked(FALSE);
  sendenohnezf->setGeometry(10,120,400,20);
  bandmodeum = new QCheckBox(diverses);
  bandmodeum->setText(tr("Band-Modeumschaltung ueber Menue","CheckBox divers"));
  bandmodeum->setChecked(FALSE);
  bandmodeum->setGeometry(10,140,300,20);
  vfox4 = new QCheckBox(diverses);
  vfox4->setText(tr("VFO x 4 fuer I/Q Mischer","CheckBox divers"));
  vfox4->setChecked(FALSE);
  vfox4->setGeometry(10,160,250,20);
  autostep = new QCheckBox(diverses);
  autostep->setText(tr("Step automatisch","CheckBox divers"));
  autostep->setChecked(FALSE);
  autostep->setGeometry(10,180,250,20);
  mton = new QLineEdit(diverses);
  mton->setGeometry(150,220,80,20);
  labelmton = new QLabel(tr("Mithoerton Hz","divers"), diverses);
  labelmton->setGeometry(10,220,130,20);
  labelmton->setAlignment(Qt::AlignRight);
  txhang = new QSpinBox(diverses);
  txhang->setGeometry(150,245,80,20);
  txhang->setRange(0, 1275);
  txhang->setSingleStep(5);
  labeltxhang = new QLabel(tr("TX hang time mSek.","divers"), diverses);
  labeltxhang->setGeometry(10,245,130,20);
  labeltxhang->setAlignment(Qt::AlignRight);
  geeversion = new QGroupBox(tr("Version der Eepromdaten"), grunddaten);
  geeversion->setGeometry(10,230,200,60);
  version100 = new QRadioButton(geeversion);
  version100->setGeometry(10,20,180,20);
  version100->setText(tr("Version 100 (alt)"));
  version100->setChecked(false);
  version101 = new QRadioButton(geeversion);
  version101->setGeometry(10,40,180,20);
  version101->setText(tr("Version 101 (neu)"));
  version101->setChecked(false);
//=============================================================
  fmess = new QWidget();
  awidget->addTab(fmess, tr("Mess.","TabWindow"));
//--------------------------------------------------------------  
  vfomess = new QGroupBox(tr("VFO (alles in Hz)","GroupBox"), fmess);
  vfomess->setGeometry(10,10,170,90);
  edvfoamess = new QLineEdit(vfomess);
  edvfoamess->setGeometry(50,20,100,20);
  edvfobmess = new QLineEdit(vfomess);
  edvfobmess->setGeometry(50,40,100,20);
  labelvfoamess = new QLabel(tr("VFO A","Label"), vfomess);
  labelvfoamess->setGeometry(10,20,40,20);
  labelvfobmess = new QLabel(tr("VFO B","Label"), vfomess);
  labelvfobmess->setGeometry(10,40,40,20); 
//=============================================================
  f160m = new QWidget();
  awidget->addTab(f160m, tr("160m","TabWindow"));
//--------------------------------------------------------------  
  vfo160m = new QGroupBox(tr("VFO (alles in Hz)","GroupBox"), f160m);
  vfo160m->setGeometry(10,10,170,90);
  edvfoa160m = new QLineEdit(vfo160m);
  edvfoa160m->setGeometry(50,20,100,20);
  edvfob160m = new QLineEdit(vfo160m);
  edvfob160m->setGeometry(50,40,100,20);
  labelvfoa160m = new QLabel(tr("VFO A","Label"), vfo160m);
  labelvfoa160m->setGeometry(10,20,40,20);
  labelvfob160m = new QLabel(tr("VFO B","Label"), vfo160m);
  labelvfob160m->setGeometry(10,40,40,20); 
  mzf160m = new QCheckBox(vfo160m);
  mzf160m->setText(tr("VFO = RX - ZF","CheckBox vfo"));
  mzf160m->setChecked(FALSE);
  mzf160m->setGeometry(10,60,150,20);
//----------------------------------------------------------------  
  gmodea160m = new QGroupBox(tr("Mode VFO A","GroupBox"), f160m);
  gmodea160m->setGeometry(10,120,100,160);
  cwa160m = new QRadioButton(gmodea160m);
  cwa160m->setText(tr("CW"));
  cwa160m->setGeometry(10,20,80,20);
  cwa160m->setChecked(TRUE);
  cwra160m = new QRadioButton(gmodea160m);
  cwra160m->setText(tr("CWr"));
  cwra160m->setGeometry(10,40,80,20);
  usba160m = new QRadioButton(gmodea160m);
  usba160m->setText(tr("USB"));
  usba160m->setGeometry(10,60,80,20);
  lsba160m = new QRadioButton(gmodea160m);
  lsba160m->setText(tr("LSB"));
  lsba160m->setGeometry(10,80,80,20);
  diga160m = new QRadioButton(gmodea160m);
  diga160m->setText(tr("DIG"));
  diga160m->setGeometry(10,100,80,20);
  digra160m = new QRadioButton(gmodea160m);
  digra160m->setText(tr("DIGr"));
  digra160m->setGeometry(10,120,80,20);
//----------------------------------------------------------------  
  gmodeb160m = new QGroupBox(tr("Mode VFO B","GroupBox"), f160m);
  gmodeb160m->setGeometry(120,120,100,160);
  cwb160m = new QRadioButton(gmodeb160m);
  cwb160m->setText(tr("CW"));
  cwb160m->setGeometry(10,20,80,20);
  cwb160m->setChecked(TRUE);
  cwrb160m = new QRadioButton(gmodeb160m);
  cwrb160m->setText(tr("CWr"));
  cwrb160m->setGeometry(10,40,80,20);
  usbb160m = new QRadioButton(gmodeb160m);
  usbb160m->setText(tr("USB"));
  usbb160m->setGeometry(10,60,80,20);
  lsbb160m = new QRadioButton(gmodeb160m);
  lsbb160m->setText(tr("LSB"));
  lsbb160m->setGeometry(10,80,80,20);
  digb160m = new QRadioButton(gmodeb160m);
  digb160m->setText(tr("DIG"));
  digb160m->setGeometry(10,100,80,20);
  digrb160m = new QRadioButton(gmodeb160m);
  digrb160m->setText(tr("DIGr"));
  digrb160m->setGeometry(10,120,80,20);
//=============================================================
  f80m = new QWidget();
  awidget->addTab(f80m, tr("80m","TabWindow"));
//--------------------------------------------------------------  
  vfo80m = new QGroupBox(tr("VFO (alles in Hz)","GroupBox"), f80m);
  vfo80m->setGeometry(10,10,170,90);
  edvfoa80m = new QLineEdit(vfo80m);
  edvfoa80m->setGeometry(50,20,100,20);
  edvfob80m = new QLineEdit(vfo80m);
  edvfob80m->setGeometry(50,40,100,20);
  labelvfoa80m = new QLabel(tr("VFO A","Label"), vfo80m);
  labelvfoa80m->setGeometry(10,20,40,20);
  labelvfob80m = new QLabel(tr("VFO B","Label"), vfo80m);
  labelvfob80m->setGeometry(10,40,40,20); 
  mzf80m = new QCheckBox(vfo80m);
  mzf80m->setText(tr("VFO = RX - ZF","CheckBox vfo"));
  mzf80m->setChecked(FALSE);
  mzf80m->setGeometry(10,60,150,20);
//----------------------------------------------------------------  
  gmodea80m = new QGroupBox(tr("Mode VFO A","GroupBox"), f80m);
  gmodea80m->setGeometry(10,120,100,160);
  cwa80m = new QRadioButton(gmodea80m);
  cwa80m->setText(tr("CW"));
  cwa80m->setGeometry(10,20,80,20);
  cwa80m->setChecked(TRUE);
  cwra80m = new QRadioButton(gmodea80m);
  cwra80m->setText(tr("CWr"));
  cwra80m->setGeometry(10,40,80,20);
  usba80m = new QRadioButton(gmodea80m);
  usba80m->setText(tr("USB"));
  usba80m->setGeometry(10,60,80,20);
  lsba80m = new QRadioButton(gmodea80m);
  lsba80m->setText(tr("LSB"));
  lsba80m->setGeometry(10,80,80,20);
  diga80m = new QRadioButton(gmodea80m);
  diga80m->setText(tr("DIG"));
  diga80m->setGeometry(10,100,80,20);
  digra80m = new QRadioButton(gmodea80m);
  digra80m->setText(tr("DIGr"));
  digra80m->setGeometry(10,120,80,20);
//----------------------------------------------------------------  
  gmodeb80m = new QGroupBox(tr("Mode VFO B","GroupBox"), f80m);
  gmodeb80m->setGeometry(120,120,100,160);
  cwb80m = new QRadioButton(gmodeb80m);
  cwb80m->setText(tr("CW"));
  cwb80m->setGeometry(10,20,80,20);
  cwb80m->setChecked(TRUE);
  cwrb80m = new QRadioButton(gmodeb80m);
  cwrb80m->setText(tr("CWr"));
  cwrb80m->setGeometry(10,40,80,20);
  usbb80m = new QRadioButton(gmodeb80m);
  usbb80m->setText(tr("USB"));
  usbb80m->setGeometry(10,60,80,20);
  lsbb80m = new QRadioButton(gmodeb80m);
  lsbb80m->setText(tr("LSB"));
  lsbb80m->setGeometry(10,80,80,20);
  digb80m = new QRadioButton(gmodeb80m);
  digb80m->setText(tr("DIG"));
  digb80m->setGeometry(10,100,80,20);
  digrb80m = new QRadioButton(gmodeb80m);
  digrb80m->setText(tr("DIGr"));
  digrb80m->setGeometry(10,120,80,20);
//=============================================================
  f60m = new QWidget();
  awidget->addTab(f60m, tr("60m","TabWindow"));
//--------------------------------------------------------------  
  vfo60m = new QGroupBox(tr("VFO (alles in Hz)","GroupBox"), f60m);
  vfo60m->setGeometry(10,10,170,90);
  edvfoa60m = new QLineEdit(vfo60m);
  edvfoa60m->setGeometry(50,20,100,20);
  edvfob60m = new QLineEdit(vfo60m);
  edvfob60m->setGeometry(50,40,100,20);
  labelvfoa60m = new QLabel(tr("VFO A","Label"), vfo60m);
  labelvfoa60m->setGeometry(10,20,40,20);
  labelvfob60m = new QLabel(tr("VFO B","Label"), vfo60m);
  labelvfob60m->setGeometry(10,40,40,20); 
  mzf60m = new QCheckBox(vfo60m);
  mzf60m->setText(tr("VFO = RX - ZF","CheckBox vfo"));
  mzf60m->setChecked(FALSE);
  mzf60m->setGeometry(10,60,150,20);
//----------------------------------------------------------------  
  gmodea60m = new QGroupBox(tr("Mode VFO A","GroupBox"), f60m);
  gmodea60m->setGeometry(10,120,100,160);
  cwa60m = new QRadioButton(gmodea60m);
  cwa60m->setText(tr("CW"));
  cwa60m->setGeometry(10,20,80,20);
  cwa60m->setChecked(TRUE);
  cwra60m = new QRadioButton(gmodea60m);
  cwra60m->setText(tr("CWr"));
  cwra60m->setGeometry(10,40,80,20);
  usba60m = new QRadioButton(gmodea60m);
  usba60m->setText(tr("USB"));
  usba60m->setGeometry(10,60,80,20);
  lsba60m = new QRadioButton(gmodea60m);
  lsba60m->setText(tr("LSB"));
  lsba60m->setGeometry(10,80,80,20);
  diga60m = new QRadioButton(gmodea60m);
  diga60m->setText(tr("DIG"));
  diga60m->setGeometry(10,100,80,20);
  digra60m = new QRadioButton(gmodea60m);
  digra60m->setText(tr("DIGr"));
  digra60m->setGeometry(10,120,80,20);
//----------------------------------------------------------------  
  gmodeb60m = new QGroupBox(tr("Mode VFO B","GroupBox"), f60m);
  gmodeb60m->setGeometry(120,120,100,160);
  cwb60m = new QRadioButton(gmodeb60m);
  cwb60m->setText(tr("CW"));
  cwb60m->setGeometry(10,20,80,20);
  cwb60m->setChecked(TRUE);
  cwrb60m = new QRadioButton(gmodeb60m);
  cwrb60m->setText(tr("CWr"));
  cwrb60m->setGeometry(10,40,80,20);
  usbb60m = new QRadioButton(gmodeb60m);
  usbb60m->setText(tr("USB"));
  usbb60m->setGeometry(10,60,80,20);
  lsbb60m = new QRadioButton(gmodeb60m);
  lsbb60m->setText(tr("LSB"));
  lsbb60m->setGeometry(10,80,80,20);
  digb60m = new QRadioButton(gmodeb60m);
  digb60m->setText(tr("DIG"));
  digb60m->setGeometry(10,100,80,20);
  digrb60m = new QRadioButton(gmodeb60m);
  digrb60m->setText(tr("DIGr"));
  digrb60m->setGeometry(10,120,80,20);
//=============================================================
  f40m = new QWidget();
  awidget->addTab(f40m, tr("40m","TabWindow"));
//--------------------------------------------------------------  
  vfo40m = new QGroupBox(tr("VFO (alles in Hz)","GroupBox"), f40m);
  vfo40m->setGeometry(10,10,170,90);
  edvfoa40m = new QLineEdit(vfo40m);
  edvfoa40m->setGeometry(50,20,100,20);
  edvfob40m = new QLineEdit(vfo40m);
  edvfob40m->setGeometry(50,40,100,20);
  labelvfoa40m = new QLabel(tr("VFO A","Label"), vfo40m);
  labelvfoa40m->setGeometry(10,20,40,20);
  labelvfob40m = new QLabel(tr("VFO B","Label"), vfo40m);
  labelvfob40m->setGeometry(10,40,40,20); 
  mzf40m = new QCheckBox(vfo40m);
  mzf40m->setText(tr("VFO = RX - ZF","CheckBox vfo"));
  mzf40m->setChecked(FALSE);
  mzf40m->setGeometry(10,60,150,20);
//----------------------------------------------------------------  
  gmodea40m = new QGroupBox(tr("Mode VFO A","GroupBox"), f40m);
  gmodea40m->setGeometry(10,120,100,160);
  cwa40m = new QRadioButton(gmodea40m);
  cwa40m->setText(tr("CW"));
  cwa40m->setGeometry(10,20,80,20);
  cwa40m->setChecked(TRUE);
  cwra40m = new QRadioButton(gmodea40m);
  cwra40m->setText(tr("CWr"));
  cwra40m->setGeometry(10,40,80,20);
  usba40m = new QRadioButton(gmodea40m);
  usba40m->setText(tr("USB"));
  usba40m->setGeometry(10,60,80,20);
  lsba40m = new QRadioButton(gmodea40m);
  lsba40m->setText(tr("LSB"));
  lsba40m->setGeometry(10,80,80,20);
  diga40m = new QRadioButton(gmodea40m);
  diga40m->setText(tr("DIG"));
  diga40m->setGeometry(10,100,80,20);
  digra40m = new QRadioButton(gmodea40m);
  digra40m->setText(tr("DIGr"));
  digra40m->setGeometry(10,120,80,20);
//----------------------------------------------------------------  
  gmodeb40m = new QGroupBox(tr("Mode VFO B","GroupBox"), f40m);
  gmodeb40m->setGeometry(120,120,100,160);
  cwb40m = new QRadioButton(gmodeb40m);
  cwb40m->setText(tr("CW"));
  cwb40m->setGeometry(10,20,80,20);
  cwb40m->setChecked(TRUE);
  cwrb40m = new QRadioButton(gmodeb40m);
  cwrb40m->setText(tr("CWr"));
  cwrb40m->setGeometry(10,40,80,20);
  usbb40m = new QRadioButton(gmodeb40m);
  usbb40m->setText(tr("USB"));
  usbb40m->setGeometry(10,60,80,20);
  lsbb40m = new QRadioButton(gmodeb40m);
  lsbb40m->setText(tr("LSB"));
  lsbb40m->setGeometry(10,80,80,20);
  digb40m = new QRadioButton(gmodeb40m);
  digb40m->setText(tr("DIG"));
  digb40m->setGeometry(10,100,80,20);
  digrb40m = new QRadioButton(gmodeb40m);
  digrb40m->setText(tr("DIGr"));
  digrb40m->setGeometry(10,120,80,20);
//=============================================================
//=============================================================
  f30m = new QWidget();
  awidget->addTab(f30m, tr("30m","TabWindow"));
//--------------------------------------------------------------  
  vfo30m = new QGroupBox(tr("VFO (alles in Hz)","GroupBox"), f30m);
  vfo30m->setGeometry(10,10,170,90);
  edvfoa30m = new QLineEdit(vfo30m);
  edvfoa30m->setGeometry(50,20,100,20);
  edvfob30m = new QLineEdit(vfo30m);
  edvfob30m->setGeometry(50,40,100,20);
  labelvfoa30m = new QLabel(tr("VFO A","Label"), vfo30m);
  labelvfoa30m->setGeometry(10,20,40,20);
  labelvfob30m = new QLabel(tr("VFO B","Label"), vfo30m);
  labelvfob30m->setGeometry(10,40,40,20); 
  mzf30m = new QCheckBox(vfo30m);
  mzf30m->setText(tr("VFO = RX - ZF","CheckBox vfo"));
  mzf30m->setChecked(FALSE);
  mzf30m->setGeometry(10,60,150,20);
//----------------------------------------------------------------  
  gmodea30m = new QGroupBox(tr("Mode VFO A","GroupBox"), f30m);
  gmodea30m->setGeometry(10,120,100,160);
  cwa30m = new QRadioButton(gmodea30m);
  cwa30m->setText(tr("CW"));
  cwa30m->setGeometry(10,20,80,20);
  cwa30m->setChecked(TRUE);
  cwra30m = new QRadioButton(gmodea30m);
  cwra30m->setText(tr("CWr"));
  cwra30m->setGeometry(10,40,80,20);
  usba30m = new QRadioButton(gmodea30m);
  usba30m->setText(tr("USB"));
  usba30m->setGeometry(10,60,80,20);
  lsba30m = new QRadioButton(gmodea30m);
  lsba30m->setText(tr("LSB"));
  lsba30m->setGeometry(10,80,80,20);
  diga30m = new QRadioButton(gmodea30m);
  diga30m->setText(tr("DIG"));
  diga30m->setGeometry(10,100,80,20);
  digra30m = new QRadioButton(gmodea30m);
  digra30m->setText(tr("DIGr"));
  digra30m->setGeometry(10,120,80,20);
//----------------------------------------------------------------  
  gmodeb30m = new QGroupBox(tr("Mode VFO B","GroupBox"), f30m);
  gmodeb30m->setGeometry(120,120,100,160);
  cwb30m = new QRadioButton(gmodeb30m);
  cwb30m->setText(tr("CW"));
  cwb30m->setGeometry(10,20,80,20);
  cwb30m->setChecked(TRUE);
  cwrb30m = new QRadioButton(gmodeb30m);
  cwrb30m->setText(tr("CWr"));
  cwrb30m->setGeometry(10,40,80,20);
  usbb30m = new QRadioButton(gmodeb30m);
  usbb30m->setText(tr("USB"));
  usbb30m->setGeometry(10,60,80,20);
  lsbb30m = new QRadioButton(gmodeb30m);
  lsbb30m->setText(tr("LSB"));
  lsbb30m->setGeometry(10,80,80,20);
  digb30m = new QRadioButton(gmodeb30m);
  digb30m->setText(tr("DIG"));
  digb30m->setGeometry(10,100,80,20);
  digrb30m = new QRadioButton(gmodeb30m);
  digrb30m->setText(tr("DIGr"));
  digrb30m->setGeometry(10,120,80,20);
//=============================================================
  f20m = new QWidget();
  awidget->addTab(f20m, tr("20m","TabWindow"));
//--------------------------------------------------------------  
  vfo20m = new QGroupBox(tr("VFO (alles in Hz)","GroupBox"), f20m);
  vfo20m->setGeometry(10,10,170,90);
  edvfoa20m = new QLineEdit(vfo20m);
  edvfoa20m->setGeometry(50,20,100,20);
  edvfob20m = new QLineEdit(vfo20m);
  edvfob20m->setGeometry(50,40,100,20);
  labelvfoa20m = new QLabel(tr("VFO A","Label"), vfo20m);
  labelvfoa20m->setGeometry(10,20,40,20);
  labelvfob20m = new QLabel(tr("VFO B","Label"), vfo20m);
  labelvfob20m->setGeometry(10,40,40,20); 
  mzf20m = new QCheckBox(vfo20m);
  mzf20m->setText(tr("VFO = RX - ZF","CheckBox vfo"));
  mzf20m->setChecked(FALSE);
  mzf20m->setGeometry(10,60,150,20);
//----------------------------------------------------------------  
  gmodea20m = new QGroupBox(tr("Mode VFO A","GroupBox"), f20m);
  gmodea20m->setGeometry(10,120,100,160);
  cwa20m = new QRadioButton(gmodea20m);
  cwa20m->setText(tr("CW"));
  cwa20m->setGeometry(10,20,80,20);
  cwa20m->setChecked(TRUE);
  cwra20m = new QRadioButton(gmodea20m);
  cwra20m->setText(tr("CWr"));
  cwra20m->setGeometry(10,40,80,20);
  usba20m = new QRadioButton(gmodea20m);
  usba20m->setText(tr("USB"));
  usba20m->setGeometry(10,60,80,20);
  lsba20m = new QRadioButton(gmodea20m);
  lsba20m->setText(tr("LSB"));
  lsba20m->setGeometry(10,80,80,20);
  diga20m = new QRadioButton(gmodea20m);
  diga20m->setText(tr("DIG"));
  diga20m->setGeometry(10,100,80,20);
  digra20m = new QRadioButton(gmodea20m);
  digra20m->setText(tr("DIGr"));
  digra20m->setGeometry(10,120,80,20);
//----------------------------------------------------------------  
  gmodeb20m = new QGroupBox(tr("Mode VFO B","GroupBox"), f20m);
  gmodeb20m->setGeometry(120,120,100,160);
  cwb20m = new QRadioButton(gmodeb20m);
  cwb20m->setText(tr("CW"));
  cwb20m->setGeometry(10,20,80,20);
  cwb20m->setChecked(TRUE);
  cwrb20m = new QRadioButton(gmodeb20m);
  cwrb20m->setText(tr("CWr"));
  cwrb20m->setGeometry(10,40,80,20);
  usbb20m = new QRadioButton(gmodeb20m);
  usbb20m->setText(tr("USB"));
  usbb20m->setGeometry(10,60,80,20);
  lsbb20m = new QRadioButton(gmodeb20m);
  lsbb20m->setText(tr("LSB"));
  lsbb20m->setGeometry(10,80,80,20);
  digb20m = new QRadioButton(gmodeb20m);
  digb20m->setText(tr("DIG"));
  digb20m->setGeometry(10,100,80,20);
  digrb20m = new QRadioButton(gmodeb20m);
  digrb20m->setText(tr("DIGr"));
  digrb20m->setGeometry(10,120,80,20);
//=============================================================
  f17m = new QWidget();
  awidget->addTab(f17m, tr("17m","TabWindow"));
//--------------------------------------------------------------  
  vfo17m = new QGroupBox(tr("VFO (alles in Hz)","GroupBox"), f17m);
  vfo17m->setGeometry(10,10,170,90);
  edvfoa17m = new QLineEdit(vfo17m);
  edvfoa17m->setGeometry(50,20,100,20);
  edvfob17m = new QLineEdit(vfo17m);
  edvfob17m->setGeometry(50,40,100,20);
  labelvfoa17m = new QLabel(tr("VFO A","Label"), vfo17m);
  labelvfoa17m->setGeometry(10,20,40,20);
  labelvfob17m = new QLabel(tr("VFO B","Label"), vfo17m);
  labelvfob17m->setGeometry(10,40,40,20); 
  mzf17m = new QCheckBox(vfo17m);
  mzf17m->setText(tr("VFO = RX - ZF","CheckBox vfo"));
  mzf17m->setChecked(FALSE);
  mzf17m->setGeometry(10,60,150,20);
//----------------------------------------------------------------  
  gmodea17m = new QGroupBox(tr("Mode VFO A","GroupBox"), f17m);
  gmodea17m->setGeometry(10,120,100,160);
  cwa17m = new QRadioButton(gmodea17m);
  cwa17m->setText(tr("CW"));
  cwa17m->setGeometry(10,20,80,20);
  cwa17m->setChecked(TRUE);
  cwra17m = new QRadioButton(gmodea17m);
  cwra17m->setText(tr("CWr"));
  cwra17m->setGeometry(10,40,80,20);
  usba17m = new QRadioButton(gmodea17m);
  usba17m->setText(tr("USB"));
  usba17m->setGeometry(10,60,80,20);
  lsba17m = new QRadioButton(gmodea17m);
  lsba17m->setText(tr("LSB"));
  lsba17m->setGeometry(10,80,80,20);
  diga17m = new QRadioButton(gmodea17m);
  diga17m->setText(tr("DIG"));
  diga17m->setGeometry(10,100,80,20);
  digra17m = new QRadioButton(gmodea17m);
  digra17m->setText(tr("DIGr"));
  digra17m->setGeometry(10,120,80,20);
//----------------------------------------------------------------  
  gmodeb17m = new QGroupBox(tr("Mode VFO B","GroupBox"), f17m);
  gmodeb17m->setGeometry(120,120,100,160);
  cwb17m = new QRadioButton(gmodeb17m);
  cwb17m->setText(tr("CW"));
  cwb17m->setGeometry(10,20,80,20);
  cwb17m->setChecked(TRUE);
  cwrb17m = new QRadioButton(gmodeb17m);
  cwrb17m->setText(tr("CWr"));
  cwrb17m->setGeometry(10,40,80,20);
  usbb17m = new QRadioButton(gmodeb17m);
  usbb17m->setText(tr("USB"));
  usbb17m->setGeometry(10,60,80,20);
  lsbb17m = new QRadioButton(gmodeb17m);
  lsbb17m->setText(tr("LSB"));
  lsbb17m->setGeometry(10,80,80,20);
  digb17m = new QRadioButton(gmodeb17m);
  digb17m->setText(tr("DIG"));
  digb17m->setGeometry(10,100,80,20);
  digrb17m = new QRadioButton(gmodeb17m);
  digrb17m->setText(tr("DIGr"));
  digrb17m->setGeometry(10,120,80,20);
//=============================================================
  f15m = new QWidget();
  awidget->addTab(f15m, tr("15m","TabWindow"));
//--------------------------------------------------------------  
  vfo15m = new QGroupBox(tr("VFO (alles in Hz)","GroupBox"), f15m);
  vfo15m->setGeometry(10,10,170,90);
  edvfoa15m = new QLineEdit(vfo15m);
  edvfoa15m->setGeometry(50,20,100,20);
  edvfob15m = new QLineEdit(vfo15m);
  edvfob15m->setGeometry(50,40,100,20);
  labelvfoa15m = new QLabel(tr("VFO A","Label"), vfo15m);
  labelvfoa15m->setGeometry(10,20,40,20);
  labelvfob15m = new QLabel(tr("VFO B","Label"), vfo15m);
  labelvfob15m->setGeometry(10,40,40,20); 
  mzf15m = new QCheckBox(vfo15m);
  mzf15m->setText(tr("VFO = RX - ZF","CheckBox vfo"));
  mzf15m->setChecked(FALSE);
  mzf15m->setGeometry(10,60,150,20);
//----------------------------------------------------------------  
  gmodea15m = new QGroupBox(tr("Mode VFO A","GroupBox"), f15m);
  gmodea15m->setGeometry(10,120,100,160);
  cwa15m = new QRadioButton(gmodea15m);
  cwa15m->setText(tr("CW"));
  cwa15m->setGeometry(10,20,80,20);
  cwa15m->setChecked(TRUE);
  cwra15m = new QRadioButton(gmodea15m);
  cwra15m->setText(tr("CWr"));
  cwra15m->setGeometry(10,40,80,20);
  usba15m = new QRadioButton(gmodea15m);
  usba15m->setText(tr("USB"));
  usba15m->setGeometry(10,60,80,20);
  lsba15m = new QRadioButton(gmodea15m);
  lsba15m->setText(tr("LSB"));
  lsba15m->setGeometry(10,80,80,20);
  diga15m = new QRadioButton(gmodea15m);
  diga15m->setText(tr("DIG"));
  diga15m->setGeometry(10,100,80,20);
  digra15m = new QRadioButton(gmodea15m);
  digra15m->setText(tr("DIGr"));
  digra15m->setGeometry(10,120,80,20);
//----------------------------------------------------------------  
  gmodeb15m = new QGroupBox(tr("Mode VFO B","GroupBox"), f15m);
  gmodeb15m->setGeometry(120,120,100,160);
  cwb15m = new QRadioButton(gmodeb15m);
  cwb15m->setText(tr("CW"));
  cwb15m->setGeometry(10,20,80,20);
  cwb15m->setChecked(TRUE);
  cwrb15m = new QRadioButton(gmodeb15m);
  cwrb15m->setText(tr("CWr"));
  cwrb15m->setGeometry(10,40,80,20);
  usbb15m = new QRadioButton(gmodeb15m);
  usbb15m->setText(tr("USB"));
  usbb15m->setGeometry(10,60,80,20);
  lsbb15m = new QRadioButton(gmodeb15m);
  lsbb15m->setText(tr("LSB"));
  lsbb15m->setGeometry(10,80,80,20);
  digb15m = new QRadioButton(gmodeb15m);
  digb15m->setText(tr("DIG"));
  digb15m->setGeometry(10,100,80,20);
  digrb15m = new QRadioButton(gmodeb15m);
  digrb15m->setText(tr("DIGr"));
  digrb15m->setGeometry(10,120,80,20);
//=============================================================
  f12m = new QWidget();
  awidget->addTab(f12m, tr("12m","TabWindow"));
//--------------------------------------------------------------  
  vfo12m = new QGroupBox(tr("VFO (alles in Hz)","GroupBox"), f12m);
  vfo12m->setGeometry(10,10,170,90);
  edvfoa12m = new QLineEdit(vfo12m);
  edvfoa12m->setGeometry(50,20,100,20);
  edvfob12m = new QLineEdit(vfo12m);
  edvfob12m->setGeometry(50,40,100,20);
  labelvfoa12m = new QLabel(tr("VFO A","Label"), vfo12m);
  labelvfoa12m->setGeometry(10,20,40,20);
  labelvfob12m = new QLabel(tr("VFO B","Label"), vfo12m);
  labelvfob12m->setGeometry(10,40,40,20); 
  mzf12m = new QCheckBox(vfo12m);
  mzf12m->setText(tr("VFO = RX - ZF","CheckBox vfo"));
  mzf12m->setChecked(FALSE);
  mzf12m->setGeometry(10,60,150,20);
//----------------------------------------------------------------  
  gmodea12m = new QGroupBox(tr("Mode VFO A","GroupBox"), f12m);
  gmodea12m->setGeometry(10,120,100,160);
  cwa12m = new QRadioButton(gmodea12m);
  cwa12m->setText(tr("CW"));
  cwa12m->setGeometry(10,20,80,20);
  cwa12m->setChecked(TRUE);
  cwra12m = new QRadioButton(gmodea12m);
  cwra12m->setText(tr("CWr"));
  cwra12m->setGeometry(10,40,80,20);
  usba12m = new QRadioButton(gmodea12m);
  usba12m->setText(tr("USB"));
  usba12m->setGeometry(10,60,80,20);
  lsba12m = new QRadioButton(gmodea12m);
  lsba12m->setText(tr("LSB"));
  lsba12m->setGeometry(10,80,80,20);
  diga12m = new QRadioButton(gmodea12m);
  diga12m->setText(tr("DIG"));
  diga12m->setGeometry(10,100,80,20);
  digra12m = new QRadioButton(gmodea12m);
  digra12m->setText(tr("DIGr"));
  digra12m->setGeometry(10,120,80,20);
//----------------------------------------------------------------  
  gmodeb12m = new QGroupBox(tr("Mode VFO B","GroupBox"), f12m);
  gmodeb12m->setGeometry(120,120,100,160);
  cwb12m = new QRadioButton(gmodeb12m);
  cwb12m->setText(tr("CW"));
  cwb12m->setGeometry(10,20,80,20);
  cwb12m->setChecked(TRUE);
  cwrb12m = new QRadioButton(gmodeb12m);
  cwrb12m->setText(tr("CWr"));
  cwrb12m->setGeometry(10,40,80,20);
  usbb12m = new QRadioButton(gmodeb12m);
  usbb12m->setText(tr("USB"));
  usbb12m->setGeometry(10,60,80,20);
  lsbb12m = new QRadioButton(gmodeb12m);
  lsbb12m->setText(tr("LSB"));
  lsbb12m->setGeometry(10,80,80,20);
  digb12m = new QRadioButton(gmodeb12m);
  digb12m->setText(tr("DIG"));
  digb12m->setGeometry(10,100,80,20);
  digrb12m = new QRadioButton(gmodeb12m);
  digrb12m->setText(tr("DIGr"));
  digrb12m->setGeometry(10,120,80,20);
//=============================================================
  f10m = new QWidget();
  awidget->addTab(f10m, tr("10m","TabWindow"));
//--------------------------------------------------------------  
  vfo10m = new QGroupBox(tr("VFO (alles in Hz)","GroupBox"), f10m);
  vfo10m->setGeometry(10,10,170,90);
  edvfoa10m = new QLineEdit(vfo10m);
  edvfoa10m->setGeometry(50,20,100,20);
  edvfob10m = new QLineEdit(vfo10m);
  edvfob10m->setGeometry(50,40,100,20);
  labelvfoa10m = new QLabel(tr("VFO A","Label"), vfo10m);
  labelvfoa10m->setGeometry(10,20,40,20);
  labelvfob10m = new QLabel(tr("VFO B","Label"), vfo10m);
  labelvfob10m->setGeometry(10,40,40,20); 
  mzf10m = new QCheckBox(vfo10m);
  mzf10m->setText(tr("VFO = RX - ZF","CheckBox vfo"));
  mzf10m->setChecked(FALSE);
  mzf10m->setGeometry(10,60,150,20);
//----------------------------------------------------------------  
  gmodea10m = new QGroupBox(tr("Mode VFO A","GroupBox"), f10m);
  gmodea10m->setGeometry(10,120,100,160);
  cwa10m = new QRadioButton(gmodea10m);
  cwa10m->setText(tr("CW"));
  cwa10m->setGeometry(10,20,80,20);
  cwa10m->setChecked(TRUE);
  cwra10m = new QRadioButton(gmodea10m);
  cwra10m->setText(tr("CWr"));
  cwra10m->setGeometry(10,40,80,20);
  usba10m = new QRadioButton(gmodea10m);
  usba10m->setText(tr("USB"));
  usba10m->setGeometry(10,60,80,20);
  lsba10m = new QRadioButton(gmodea10m);
  lsba10m->setText(tr("LSB"));
  lsba10m->setGeometry(10,80,80,20);
  diga10m = new QRadioButton(gmodea10m);
  diga10m->setText(tr("DIG"));
  diga10m->setGeometry(10,100,80,20);
  digra10m = new QRadioButton(gmodea10m);
  digra10m->setText(tr("DIGr"));
  digra10m->setGeometry(10,120,80,20);
//----------------------------------------------------------------  
  gmodeb10m = new QGroupBox(tr("Mode VFO B","GroupBox"), f10m);
  gmodeb10m->setGeometry(120,120,100,160);
  cwb10m = new QRadioButton(gmodeb10m);
  cwb10m->setText(tr("CW"));
  cwb10m->setGeometry(10,20,80,20);
  cwb10m->setChecked(TRUE);
  cwrb10m = new QRadioButton(gmodeb10m);
  cwrb10m->setText(tr("CWr"));
  cwrb10m->setGeometry(10,40,80,20);
  usbb10m = new QRadioButton(gmodeb10m);
  usbb10m->setText(tr("USB"));
  usbb10m->setGeometry(10,60,80,20);
  lsbb10m = new QRadioButton(gmodeb10m);
  lsbb10m->setText(tr("LSB"));
  lsbb10m->setGeometry(10,80,80,20);
  digb10m = new QRadioButton(gmodeb10m);
  digb10m->setText(tr("DIG"));
  digb10m->setGeometry(10,100,80,20);
  digrb10m = new QRadioButton(gmodeb10m);
  digrb10m->setText(tr("DIGr"));
  digrb10m->setGeometry(10,120,80,20);
//=============================================================
  f6m = new QWidget();
  awidget->addTab(f6m, tr("6m","TabWindow"));
//--------------------------------------------------------------  
  vfo6m = new QGroupBox(tr("VFO (alles in Hz)","GroupBox"), f6m);
  vfo6m->setGeometry(10,10,170,90);
  edvfoa6m = new QLineEdit(vfo6m);
  edvfoa6m->setGeometry(50,20,100,20);
  edvfob6m = new QLineEdit(vfo6m);
  edvfob6m->setGeometry(50,40,100,20);
  labelvfoa6m = new QLabel(tr("VFO A","Label"), vfo6m);
  labelvfoa6m->setGeometry(10,20,40,20);
  labelvfob6m = new QLabel(tr("VFO B","Label"), vfo6m);
  labelvfob6m->setGeometry(10,40,40,20); 
  mzf6m = new QCheckBox(vfo6m);
  mzf6m->setText(tr("VFO = RX - ZF","CheckBox vfo"));
  mzf6m->setChecked(FALSE);
  mzf6m->setGeometry(10,60,150,20);
//----------------------------------------------------------------  
  gmodea6m = new QGroupBox(tr("Mode VFO A","GroupBox"), f6m);
  gmodea6m->setGeometry(10,120,100,160);
  cwa6m = new QRadioButton(gmodea6m);
  cwa6m->setText(tr("CW"));
  cwa6m->setGeometry(10,20,80,20);
  cwa6m->setChecked(TRUE);
  cwra6m = new QRadioButton(gmodea6m);
  cwra6m->setText(tr("CWr"));
  cwra6m->setGeometry(10,40,80,20);
  usba6m = new QRadioButton(gmodea6m);
  usba6m->setText(tr("USB"));
  usba6m->setGeometry(10,60,80,20);
  lsba6m = new QRadioButton(gmodea6m);
  lsba6m->setText(tr("LSB"));
  lsba6m->setGeometry(10,80,80,20);
  diga6m = new QRadioButton(gmodea6m);
  diga6m->setText(tr("DIG"));
  diga6m->setGeometry(10,100,80,20);
  digra6m = new QRadioButton(gmodea6m);
  digra6m->setText(tr("DIGr"));
  digra6m->setGeometry(10,120,80,20);
//----------------------------------------------------------------  
  gmodeb6m = new QGroupBox(tr("Mode VFO B","GroupBox"), f6m);
  gmodeb6m->setGeometry(120,120,100,160);
  cwb6m = new QRadioButton(gmodeb6m);
  cwb6m->setText(tr("CW"));
  cwb6m->setGeometry(10,20,80,20);
  cwb6m->setChecked(TRUE);
  cwrb6m = new QRadioButton(gmodeb6m);
  cwrb6m->setText(tr("CWr"));
  cwrb6m->setGeometry(10,40,80,20);
  usbb6m = new QRadioButton(gmodeb6m);
  usbb6m->setText(tr("USB"));
  usbb6m->setGeometry(10,60,80,20);
  lsbb6m = new QRadioButton(gmodeb6m);
  lsbb6m->setText(tr("LSB"));
  lsbb6m->setGeometry(10,80,80,20);
  digb6m = new QRadioButton(gmodeb6m);
  digb6m->setText(tr("DIG"));
  digb6m->setGeometry(10,100,80,20);
  digrb6m = new QRadioButton(gmodeb6m);
  digrb6m->setText(tr("DIGr"));
  digrb6m->setGeometry(10,120,80,20);
//=============================================================
  f2m = new QWidget();
  awidget->addTab(f2m, tr("2m","TabWindow"));
//--------------------------------------------------------------  
  vfo2m = new QGroupBox(tr("VFO (alles in Hz)","GroupBox"), f2m);
  vfo2m->setGeometry(10,10,170,90);
  edvfoa2m = new QLineEdit(vfo2m);
  edvfoa2m->setGeometry(50,20,100,20);
  edvfob2m = new QLineEdit(vfo2m);
  edvfob2m->setGeometry(50,40,100,20);
  labelvfoa2m = new QLabel(tr("VFO A","Label"), vfo2m);
  labelvfoa2m->setGeometry(10,20,40,20);
  labelvfob2m = new QLabel(tr("VFO B","Label"), vfo2m);
  labelvfob2m->setGeometry(10,40,40,20); 
  mzf2m = new QCheckBox(vfo2m);
  mzf2m->setText(tr("VFO = RX - ZF","CheckBox vfo"));
  mzf2m->setChecked(FALSE);
  mzf2m->setGeometry(10,60,150,20);
//----------------------------------------------------------------  
  gmodea2m = new QGroupBox(tr("Mode VFO A","GroupBox"), f2m);
  gmodea2m->setGeometry(10,120,100,160);
  cwa2m = new QRadioButton(gmodea2m);
  cwa2m->setText(tr("CW"));
  cwa2m->setGeometry(10,20,80,20);
  cwa2m->setChecked(TRUE);
  cwra2m = new QRadioButton(gmodea2m);
  cwra2m->setText(tr("CWr"));
  cwra2m->setGeometry(10,40,80,20);
  usba2m = new QRadioButton(gmodea2m);
  usba2m->setText(tr("USB"));
  usba2m->setGeometry(10,60,80,20);
  lsba2m = new QRadioButton(gmodea2m);
  lsba2m->setText(tr("LSB"));
  lsba2m->setGeometry(10,80,80,20);
  diga2m = new QRadioButton(gmodea2m);
  diga2m->setText(tr("DIG"));
  diga2m->setGeometry(10,100,80,20);
  digra2m = new QRadioButton(gmodea2m);
  digra2m->setText(tr("DIGr"));
  digra2m->setGeometry(10,120,80,20);
//----------------------------------------------------------------  
  gmodeb2m = new QGroupBox(tr("Mode VFO B","GroupBox"), f2m);
  gmodeb2m->setGeometry(120,120,100,160);
  cwb2m = new QRadioButton(gmodeb2m);
  cwb2m->setText(tr("CW"));
  cwb2m->setGeometry(10,20,80,20);
  cwb2m->setChecked(TRUE);
  cwrb2m = new QRadioButton(gmodeb2m);
  cwrb2m->setText(tr("CWr"));
  cwrb2m->setGeometry(10,40,80,20);
  usbb2m = new QRadioButton(gmodeb2m);
  usbb2m->setText(tr("USB"));
  usbb2m->setGeometry(10,60,80,20);
  lsbb2m = new QRadioButton(gmodeb2m);
  lsbb2m->setText(tr("LSB"));
  lsbb2m->setGeometry(10,80,80,20);
  digb2m = new QRadioButton(gmodeb2m);
  digb2m->setText(tr("DIG"));
  digb2m->setGeometry(10,100,80,20);
  digrb2m = new QRadioButton(gmodeb2m);
  digrb2m->setText(tr("DIGr"));
  digrb2m->setGeometry(10,120,80,20);
//=============================================================
  tv1 = new QWidget();
  awidget->addTab(tv1, tr("TV 1","TabWindow"));
  vfotv1 = new QGroupBox(tr("VFO (alles in Hz)","GroupBox"), tv1);
  vfotv1->setGeometry(10,10,170,90);
  edvfoatv1 = new QLineEdit(vfotv1);
  QObject::connect( edvfoatv1, SIGNAL(textChanged(QString)), this, SLOT(displayshiftset1(QString)));
  edvfoatv1->setGeometry(50,20,100,20);
  edvfobtv1 = new QLineEdit(vfotv1);
  edvfobtv1->setGeometry(50,40,100,20);
  labelvfoatv1 = new QLabel(tr("VFO A","Label"), vfotv1);
  labelvfoatv1->setGeometry(10,20,40,20);
  labelvfobtv1 = new QLabel(tr("VFO B","Label"), vfotv1);
  labelvfobtv1->setGeometry(10,40,40,20); 
  mzftv1 = new QCheckBox(vfotv1);
  mzftv1->setText(tr("VFO = RX - ZF","CheckBox tv"));
  mzftv1->setChecked(FALSE);
  mzftv1->setGeometry(10,60,150,20);
//----------------------------------------------------------------  
  gmodeatv1 = new QGroupBox(tr("Mode VFO A","GroupBox"), tv1);
  gmodeatv1->setGeometry(10,120,100,160);
  cwatv1 = new QRadioButton(gmodeatv1);
  cwatv1->setText(tr("CW"));
  cwatv1->setGeometry(10,20,80,20);
  cwatv1->setChecked(TRUE);
  cwratv1 = new QRadioButton(gmodeatv1);
  cwratv1->setText(tr("CWr"));
  cwratv1->setGeometry(10,40,80,20);
  usbatv1 = new QRadioButton(gmodeatv1);
  usbatv1->setText(tr("USB"));
  usbatv1->setGeometry(10,60,80,20);
  lsbatv1 = new QRadioButton(gmodeatv1);
  lsbatv1->setText(tr("LSB"));
  lsbatv1->setGeometry(10,80,80,20);
  digatv1 = new QRadioButton(gmodeatv1);
  digatv1->setText(tr("DIG"));
  digatv1->setGeometry(10,100,80,20);
  digratv1 = new QRadioButton(gmodeatv1);
  digratv1->setText(tr("DIGr"));
  digratv1->setGeometry(10,120,80,20);
//----------------------------------------------------------------  
  gmodebtv1 = new QGroupBox(tr("Mode VFO B","GroupBox"), tv1);
  gmodebtv1->setGeometry(120,120,100,160);
  cwbtv1 = new QRadioButton(gmodebtv1);
  cwbtv1->setText(tr("CW"));
  cwbtv1->setGeometry(10,20,80,20);
  cwbtv1->setChecked(TRUE);
  cwrbtv1 = new QRadioButton(gmodebtv1);
  cwrbtv1->setText(tr("CWr"));
  cwrbtv1->setGeometry(10,40,80,20);
  usbbtv1 = new QRadioButton(gmodebtv1);
  usbbtv1->setText(tr("USB"));
  usbbtv1->setGeometry(10,60,80,20);
  lsbbtv1 = new QRadioButton(gmodebtv1);
  lsbbtv1->setText(tr("LSB"));
  lsbbtv1->setGeometry(10,80,80,20);
  digbtv1 = new QRadioButton(gmodebtv1);
  digbtv1->setText(tr("DIG"));
  digbtv1->setGeometry(10,100,80,20);
  digrbtv1 = new QRadioButton(gmodebtv1);
  digrbtv1->setText(tr("DIGr"));
  digrbtv1->setGeometry(10,120,80,20);
//----------------------------------------------------------------  
  displaytv1 = new QGroupBox(tr("Display-Anzeige (alles in Hz)","GroupBox"), tv1);
  displaytv1->setGeometry(190,20,190,70);
  frqtv1 = new QLineEdit(displaytv1);
  frqtv1->setGeometry(70,20,100,20);
  QObject::connect( frqtv1, SIGNAL(textChanged(QString)), this, SLOT(displayshiftset1(QString)));
  labelfrqtv1 = new QLabel(tr("Frequenz","Label"), displaytv1);
  labelfrqtv1->setGeometry(10,20,60,20);
  shifttv1 = new QLabel(tr("","Label"), displaytv1);
  shifttv1->setGeometry(70,40,100,20);
  labelshifttv1 = new QLabel(tr("Shift","Label"), displaytv1);
  labelshifttv1->setGeometry(10,40,60,20);
//----------------------------------------------------------------  
//=============================================================
  tv2 = new QWidget();
  awidget->addTab(tv2, tr("TV 2","TabWindow"));
  vfotv2 = new QGroupBox(tr("VFO (alles in Hz)","GroupBox"), tv2);
  vfotv2->setGeometry(10,10,170,90);
  edvfoatv2 = new QLineEdit(vfotv2);
  QObject::connect( edvfoatv2, SIGNAL(textChanged(QString)), this, SLOT(displayshiftset2(QString)));
  edvfoatv2->setGeometry(50,20,100,20);
  edvfobtv2 = new QLineEdit(vfotv2);
  edvfobtv2->setGeometry(50,40,100,20);
  labelvfoatv2 = new QLabel(tr("VFO A","Label"), vfotv2);
  labelvfoatv2->setGeometry(10,20,40,20);
  labelvfobtv2 = new QLabel(tr("VFO B","Label"), vfotv2);
  labelvfobtv2->setGeometry(10,40,40,20); 
  mzftv2 = new QCheckBox(vfotv2);
  mzftv2->setText(tr("VFO = RX - ZF","CheckBox tv"));
  mzftv2->setChecked(FALSE);
  mzftv2->setGeometry(10,60,150,20);
//----------------------------------------------------------------  
  gmodeatv2 = new QGroupBox(tr("Mode VFO A","GroupBox"), tv2);
  gmodeatv2->setGeometry(10,120,100,160);
  cwatv2 = new QRadioButton(gmodeatv2);
  cwatv2->setText(tr("CW"));
  cwatv2->setGeometry(10,20,80,20);
  cwatv2->setChecked(TRUE);
  cwratv2 = new QRadioButton(gmodeatv2);
  cwratv2->setText(tr("CWr"));
  cwratv2->setGeometry(10,40,80,20);
  usbatv2 = new QRadioButton(gmodeatv2);
  usbatv2->setText(tr("USB"));
  usbatv2->setGeometry(10,60,80,20);
  lsbatv2 = new QRadioButton(gmodeatv2);
  lsbatv2->setText(tr("LSB"));
  lsbatv2->setGeometry(10,80,80,20);
  digatv2 = new QRadioButton(gmodeatv2);
  digatv2->setText(tr("DIG"));
  digatv2->setGeometry(10,100,80,20);
  digratv2 = new QRadioButton(gmodeatv2);
  digratv2->setText(tr("DIGr"));
  digratv2->setGeometry(10,120,80,20);
//----------------------------------------------------------------  
  gmodebtv2 = new QGroupBox(tr("Mode VFO B","GroupBox"), tv2);
  gmodebtv2->setGeometry(120,120,100,160);
  cwbtv2 = new QRadioButton(gmodebtv2);
  cwbtv2->setText(tr("CW"));
  cwbtv2->setGeometry(10,20,80,20);
  cwbtv2->setChecked(TRUE);
  cwrbtv2 = new QRadioButton(gmodebtv2);
  cwrbtv2->setText(tr("CWr"));
  cwrbtv2->setGeometry(10,40,80,20);
  usbbtv2 = new QRadioButton(gmodebtv2);
  usbbtv2->setText(tr("USB"));
  usbbtv2->setGeometry(10,60,80,20);
  lsbbtv2 = new QRadioButton(gmodebtv2);
  lsbbtv2->setText(tr("LSB"));
  lsbbtv2->setGeometry(10,80,80,20);
  digbtv2 = new QRadioButton(gmodebtv2);
  digbtv2->setText(tr("DIG"));
  digbtv2->setGeometry(10,100,80,20);
  digrbtv2 = new QRadioButton(gmodebtv2);
  digrbtv2->setText(tr("DIGr"));
  digrbtv2->setGeometry(10,120,80,20);
//----------------------------------------------------------------  
  displaytv2 = new QGroupBox(tr("Display-Anzeige (alles in Hz)","GroupBox"), tv2);
  displaytv2->setGeometry(190,20,190,70);
  frqtv2 = new QLineEdit(displaytv2);
  QObject::connect( frqtv2, SIGNAL(textChanged(QString)), this, SLOT(displayshiftset2(QString)));
  frqtv2->setGeometry(70,20,100,20);
  labelfrqtv2 = new QLabel(tr("Frequenz","Label"), displaytv2);
  labelfrqtv2->setGeometry(10,20,60,20);
  shifttv2 = new QLabel(tr("","Label"), displaytv2);
  shifttv2->setGeometry(70,40,100,20);
  labelshifttv2 = new QLabel(tr("Shift","Label"), displaytv2);
  labelshifttv2->setGeometry(10,40,60,20);
//----------------------------------------------------------------  
//=============================================================
  tv3 = new QWidget();
  awidget->addTab(tv3, tr("TV 3","TabWindow"));
  vfotv3 = new QGroupBox(tr("VFO (alles in Hz)","GroupBox"), tv3);
  vfotv3->setGeometry(10,10,170,90);
  edvfoatv3 = new QLineEdit(vfotv3);
  QObject::connect( edvfoatv3, SIGNAL(textChanged(QString)), this, SLOT(displayshiftset3(QString)));
  edvfoatv3->setGeometry(50,20,100,20);
  edvfobtv3 = new QLineEdit(vfotv3);
  edvfobtv3->setGeometry(50,40,100,20);
  labelvfoatv3 = new QLabel(tr("VFO A","Label"), vfotv3);
  labelvfoatv3->setGeometry(10,20,40,20);
  labelvfobtv3 = new QLabel(tr("VFO B","Label"), vfotv3);
  labelvfobtv3->setGeometry(10,40,40,20); 
  mzftv3 = new QCheckBox(vfotv3);
  mzftv3->setText(tr("VFO = RX - ZF","CheckBox tv"));
  mzftv3->setChecked(FALSE);
  mzftv3->setGeometry(10,60,150,20);
//----------------------------------------------------------------  
  gmodeatv3 = new QGroupBox(tr("Mode VFO A","GroupBox"), tv3);
  gmodeatv3->setGeometry(10,120,100,160);
  cwatv3 = new QRadioButton(gmodeatv3);
  cwatv3->setText(tr("CW"));
  cwatv3->setGeometry(10,20,80,20);
  cwatv3->setChecked(TRUE);
  cwratv3 = new QRadioButton(gmodeatv3);
  cwratv3->setText(tr("CWr"));
  cwratv3->setGeometry(10,40,80,20);
  usbatv3 = new QRadioButton(gmodeatv3);
  usbatv3->setText(tr("USB"));
  usbatv3->setGeometry(10,60,80,20);
  lsbatv3 = new QRadioButton(gmodeatv3);
  lsbatv3->setText(tr("LSB"));
  lsbatv3->setGeometry(10,80,80,20);
  digatv3 = new QRadioButton(gmodeatv3);
  digatv3->setText(tr("DIG"));
  digatv3->setGeometry(10,100,80,20);
  digratv3 = new QRadioButton(gmodeatv3);
  digratv3->setText(tr("DIGr"));
  digratv3->setGeometry(10,120,80,20);
//----------------------------------------------------------------  
  gmodebtv3 = new QGroupBox(tr("Mode VFO B","GroupBox"), tv3);
  gmodebtv3->setGeometry(120,120,100,160);
  cwbtv3 = new QRadioButton(gmodebtv3);
  cwbtv3->setText(tr("CW"));
  cwbtv3->setGeometry(10,20,80,20);
  cwbtv3->setChecked(TRUE);
  cwrbtv3 = new QRadioButton(gmodebtv3);
  cwrbtv3->setText(tr("CWr"));
  cwrbtv3->setGeometry(10,40,80,20);
  usbbtv3 = new QRadioButton(gmodebtv3);
  usbbtv3->setText(tr("USB"));
  usbbtv3->setGeometry(10,60,80,20);
  lsbbtv3 = new QRadioButton(gmodebtv3);
  lsbbtv3->setText(tr("LSB"));
  lsbbtv3->setGeometry(10,80,80,20);
  digbtv3 = new QRadioButton(gmodebtv3);
  digbtv3->setText(tr("DIG"));
  digbtv3->setGeometry(10,100,80,20);
  digrbtv3 = new QRadioButton(gmodebtv3);
  digrbtv3->setText(tr("DIGr"));
  digrbtv3->setGeometry(10,120,80,20);
//----------------------------------------------------------------  
  displaytv3 = new QGroupBox(tr("Display-Anzeige (alles in Hz)","GroupBox"), tv3);
  displaytv3->setGeometry(190,20,190,70);
  frqtv3 = new QLineEdit(displaytv3);
  QObject::connect( frqtv3, SIGNAL(textChanged(QString)), this, SLOT(displayshiftset3(QString)));
  frqtv3->setGeometry(70,20,100,20);
  labelfrqtv3 = new QLabel(tr("Frequenz","Label"), displaytv3);
  labelfrqtv3->setGeometry(10,20,60,20);
  shifttv3 = new QLabel(tr("","Label"), displaytv3);
  shifttv3->setGeometry(70,40,100,20);
  labelshifttv3 = new QLabel(tr("Shift","Label"), displaytv3);
  labelshifttv3->setGeometry(10,40,60,20);
//----------------------------------------------------------------  
//=============================================================
  tv4 = new QWidget();
  awidget->addTab(tv4, tr("TV 4","TabWindow"));
  vfotv4 = new QGroupBox(tr("VFO (alles in Hz)","GroupBox"), tv4);
  vfotv4->setGeometry(10,10,170,90);
  edvfoatv4 = new QLineEdit(vfotv4);
  QObject::connect( edvfoatv4, SIGNAL(textChanged(QString)), this, SLOT(displayshiftset4(QString)));
  edvfoatv4->setGeometry(50,20,100,20);
  edvfobtv4 = new QLineEdit(vfotv4);
  edvfobtv4->setGeometry(50,40,100,20);
  labelvfoatv4 = new QLabel(tr("VFO A","Label"), vfotv4);
  labelvfoatv4->setGeometry(10,20,40,20);
  labelvfobtv4 = new QLabel(tr("VFO B","Label"), vfotv4);
  labelvfobtv4->setGeometry(10,40,40,20); 
  mzftv4 = new QCheckBox(vfotv4);
  mzftv4->setText(tr("VFO = RX - ZF","CheckBox tv"));
  mzftv4->setChecked(FALSE);
  mzftv4->setGeometry(10,60,150,20);
//----------------------------------------------------------------  
  gmodeatv4 = new QGroupBox(tr("Mode VFO A","GroupBox"), tv4);
  gmodeatv4->setGeometry(10,120,100,160);
  cwatv4 = new QRadioButton(gmodeatv4);
  cwatv4->setText(tr("CW"));
  cwatv4->setGeometry(10,20,80,20);
  cwatv4->setChecked(TRUE);
  cwratv4 = new QRadioButton(gmodeatv4);
  cwratv4->setText(tr("CWr"));
  cwratv4->setGeometry(10,40,80,20);
  usbatv4 = new QRadioButton(gmodeatv4);
  usbatv4->setText(tr("USB"));
  usbatv4->setGeometry(10,60,80,20);
  lsbatv4 = new QRadioButton(gmodeatv4);
  lsbatv4->setText(tr("LSB"));
  lsbatv4->setGeometry(10,80,80,20);
  digatv4 = new QRadioButton(gmodeatv4);
  digatv4->setText(tr("DIG"));
  digatv4->setGeometry(10,100,80,20);
  digratv4 = new QRadioButton(gmodeatv4);
  digratv4->setText(tr("DIGr"));
  digratv4->setGeometry(10,120,80,20);
//----------------------------------------------------------------  
  gmodebtv4 = new QGroupBox(tr("Mode VFO B","GroupBox"), tv4);
  gmodebtv4->setGeometry(120,120,100,160);
  cwbtv4 = new QRadioButton(gmodebtv4);
  cwbtv4->setText(tr("CW"));
  cwbtv4->setGeometry(10,20,80,20);
  cwbtv4->setChecked(TRUE);
  cwrbtv4 = new QRadioButton(gmodebtv4);
  cwrbtv4->setText(tr("CWr"));
  cwrbtv4->setGeometry(10,40,80,20);
  usbbtv4 = new QRadioButton(gmodebtv4);
  usbbtv4->setText(tr("USB"));
  usbbtv4->setGeometry(10,60,80,20);
  lsbbtv4 = new QRadioButton(gmodebtv4);
  lsbbtv4->setText(tr("LSB"));
  lsbbtv4->setGeometry(10,80,80,20);
  digbtv4 = new QRadioButton(gmodebtv4);
  digbtv4->setText(tr("DIG"));
  digbtv4->setGeometry(10,100,80,20);
  digrbtv4 = new QRadioButton(gmodebtv4);
  digrbtv4->setText(tr("DIGr"));
  digrbtv4->setGeometry(10,120,80,20);
//----------------------------------------------------------------  
  displaytv4 = new QGroupBox(tr("Display-Anzeige (alles in Hz)","GroupBox"), tv4);
  displaytv4->setGeometry(190,20,190,70);
  frqtv4 = new QLineEdit(displaytv4);
  QObject::connect( frqtv4, SIGNAL(textChanged(QString)), this, SLOT(displayshiftset4(QString)));
  frqtv4->setGeometry(70,20,100,20);
  labelfrqtv4 = new QLabel(tr("Frequenz","Label"), displaytv4);
  labelfrqtv4->setGeometry(10,20,60,20);
  shifttv4 = new QLabel(tr("","Label"), displaytv4);
  shifttv4->setGeometry(70,40,100,20);
  labelshifttv4 = new QLabel(tr("Shift","Label"), displaytv4);
  labelshifttv4->setGeometry(10,40,60,20);
//----------------------------------------------------------------  
//=============================================================
  tv5 = new QWidget();
  awidget->addTab(tv5, tr("TV 5","TabWindow"));
  vfotv5 = new QGroupBox(tr("VFO (alles in Hz)","GroupBox"), tv5);
  vfotv5->setGeometry(10,10,170,90);
  edvfoatv5 = new QLineEdit(vfotv5);
  QObject::connect( edvfoatv5, SIGNAL(textChanged(QString)), this, SLOT(displayshiftset5(QString)));
  edvfoatv5->setGeometry(50,20,100,20);
  edvfobtv5 = new QLineEdit(vfotv5);
  edvfobtv5->setGeometry(50,40,100,20);
  labelvfoatv5 = new QLabel(tr("VFO A","Label"), vfotv5);
  labelvfoatv5->setGeometry(10,20,40,20);
  labelvfobtv5 = new QLabel(tr("VFO B","Label"), vfotv5);
  labelvfobtv5->setGeometry(10,40,40,20); 
  mzftv5 = new QCheckBox(vfotv5);
  mzftv5->setText(tr("VFO = RX - ZF","CheckBox tv"));
  mzftv5->setChecked(FALSE);
  mzftv5->setGeometry(10,60,150,20);
//----------------------------------------------------------------  
  gmodeatv5 = new QGroupBox(tr("Mode VFO A","GroupBox"), tv5);
  gmodeatv5->setGeometry(10,120,100,160);
  cwatv5 = new QRadioButton(gmodeatv5);
  cwatv5->setText(tr("CW"));
  cwatv5->setGeometry(10,20,80,20);
  cwatv5->setChecked(TRUE);
  cwratv5 = new QRadioButton(gmodeatv5);
  cwratv5->setText(tr("CWr"));
  cwratv5->setGeometry(10,40,80,20);
  usbatv5 = new QRadioButton(gmodeatv5);
  usbatv5->setText(tr("USB"));
  usbatv5->setGeometry(10,60,80,20);
  lsbatv5 = new QRadioButton(gmodeatv5);
  lsbatv5->setText(tr("LSB"));
  lsbatv5->setGeometry(10,80,80,20);
  digatv5 = new QRadioButton(gmodeatv5);
  digatv5->setText(tr("DIG"));
  digatv5->setGeometry(10,100,80,20);
  digratv5 = new QRadioButton(gmodeatv5);
  digratv5->setText(tr("DIGr"));
  digratv5->setGeometry(10,120,80,20);
//----------------------------------------------------------------  
  gmodebtv5 = new QGroupBox(tr("Mode VFO B","GroupBox"), tv5);
  gmodebtv5->setGeometry(120,120,100,160);
  cwbtv5 = new QRadioButton(gmodebtv5);
  cwbtv5->setText(tr("CW"));
  cwbtv5->setGeometry(10,20,80,20);
  cwbtv5->setChecked(TRUE);
  cwrbtv5 = new QRadioButton(gmodebtv5);
  cwrbtv5->setText(tr("CWr"));
  cwrbtv5->setGeometry(10,40,80,20);
  usbbtv5 = new QRadioButton(gmodebtv5);
  usbbtv5->setText(tr("USB"));
  usbbtv5->setGeometry(10,60,80,20);
  lsbbtv5 = new QRadioButton(gmodebtv5);
  lsbbtv5->setText(tr("LSB"));
  lsbbtv5->setGeometry(10,80,80,20);
  digbtv5 = new QRadioButton(gmodebtv5);
  digbtv5->setText(tr("DIG"));
  digbtv5->setGeometry(10,100,80,20);
  digrbtv5 = new QRadioButton(gmodebtv5);
  digrbtv5->setText(tr("DIGr"));
  digrbtv5->setGeometry(10,120,80,20);
//----------------------------------------------------------------  
  displaytv5 = new QGroupBox(tr("Display-Anzeige (alles in Hz)","GroupBox"), tv5);
  displaytv5->setGeometry(190,20,190,70);
  frqtv5 = new QLineEdit(displaytv5);
  QObject::connect( frqtv5, SIGNAL(textChanged(QString)), this, SLOT(displayshiftset5(QString)));
  frqtv5->setGeometry(70,20,100,20);
  labelfrqtv5 = new QLabel(tr("Frequenz","Label"), displaytv5);
  labelfrqtv5->setGeometry(10,20,60,20);
  shifttv5 = new QLabel(tr("","Label"), displaytv5);
  shifttv5->setGeometry(70,40,100,20);
  labelshifttv5 = new QLabel(tr("Shift","Label"), displaytv5);
  labelshifttv5->setGeometry(10,40,60,20);
//----------------------------------------------------------------  
  createActions();
  createMenus();
  createToolBars();
  createStatusBar();
  
  awidget->setEnabled(FALSE);
  
  readSettings();
  picpd = new QProgressDialog("", "Abbruch", 0, 256, this);
  connect(picpd, SIGNAL(canceled()), this, SLOT(picpdcancel()));
  picpd->setWindowModality(Qt::WindowModal);
  pic2pctimer = new QTimer(this);
  connect(pic2pctimer, SIGNAL(timeout()), this, SLOT(pic2pctimerstop()));
  pc2pictimer = new QTimer(this);
  connect(pc2pictimer, SIGNAL(timeout()), this, SLOT(pc2pictimerstop()));
  timertest = new QTimer(this);
  connect(timertest, SIGNAL(timeout()), this, SLOT(timerteststop()));

  dlg = new bandmodedlg(this);
}


void avfo::getDaten()
{
  long double dkonst32 = 4294967296.0;  // 2 hoch 32
  long double dkonst28 = 268435456.0;  // 2 hoch 28
  long double dkonst24 = 16777216.0;  // 2 hoch 24
  long double dkonst16 = 65536.0;  // 2 hoch 24
  long double dkonst8 = 256.0;  // 2 hoch 24
  QString qs;
  bool ok;
  long double ddstakt;
  long double ddskonst;
  unsigned char c[5];
  int index;
  int i;
  long double zf[6];
  long double vfoa[13];
  long double vfob[13];
  long double display[5];
  bool bmzf[13];
  int modea[13];
  int modeb[13];
  unsigned char eversion = 100;
  
  for(i=0;i<256;i++)eeprombuffer[i] = buffercopy[i];
  
  //Version der Eepromdaten bestimmen
  if(version100->isChecked())eversion = 100;
  if(version101->isChecked())eversion = 101;
  qDebug("GetDaten-Eepromversion: %i",eversion);
  if(ad9833->isChecked())eeprombuffer[8]=0;
  if(ad9850->isChecked())eeprombuffer[8]=1;
  if(ad9851->isChecked())eeprombuffer[8]=2;
  if(ad9951_1->isChecked())eeprombuffer[8]=3;
  if(ad9951_2->isChecked())eeprombuffer[8]=4;
  if(ad9951_3->isChecked())eeprombuffer[8]=5;
  if(ad9951_4->isChecked())eeprombuffer[8]=6;

  qs = edddstakt->text();
  ddstakt = qs.toDouble(&ok);
  if(eeprombuffer[8]==0){
    ddskonst = dkonst32 * dkonst28 / ddstakt; //AD9833/34
  }else{
    ddskonst = dkonst32 * dkonst32 / ddstakt; //AD9850/51 AD9951
  } 
  c[4] = 0;
  if(ddskonst >= dkonst32){
    c[4] = char(ddskonst / dkonst32);
    ddskonst = ddskonst - (dkonst32 * double(c[4]));
  }
  c[3] = 0;
  if(ddskonst >= dkonst24){
    c[3] = char(ddskonst / dkonst24);
    ddskonst = ddskonst - (dkonst24 * double(c[3]));
  }
  c[2] = 0;
  if(ddskonst >= dkonst16){
    c[2] = char(ddskonst / dkonst16);
    ddskonst = ddskonst - (dkonst16 * double(c[2]));
  }
  c[1] = 0;
  if(ddskonst >= dkonst8){
    c[1] = char(ddskonst / dkonst8);
    ddskonst = ddskonst - (dkonst8 * double(c[1]));
  }
  c[0] = char(ddskonst);
  eeprombuffer[0] = c[0];
  eeprombuffer[1] = c[1];
  eeprombuffer[2] = c[2];
  eeprombuffer[3] = c[3];
  eeprombuffer[4] = c[4];
  eeprombuffer[7]=0;
  if(vfox4->isChecked())eeprombuffer[7]+=128;
  if(bandmodeum->isChecked())eeprombuffer[7]+=64;
  if(sendenohnezf->isChecked())eeprombuffer[7]+=32;
  if(keyer->isChecked())eeprombuffer[7]+=16;
  if(c1hz->isChecked())eeprombuffer[7]+=8;
  if(autolicht->isChecked())eeprombuffer[7]+=4;
  if(dauerlicht->isChecked())eeprombuffer[7]+=2;
  if(smeter->isChecked())eeprombuffer[7]+=1;
  i = txhang->value();
  eeprombuffer[9] = i / 5;
  qs = zfcw->text();
  zf[0] = qs.toDouble(&ok);
  qs = zfcwr->text();
  zf[1] = qs.toDouble(&ok);
  qs = zflsb->text();
  zf[2] = qs.toDouble(&ok);
  qs = zfusb->text();
  zf[3] = qs.toDouble(&ok);
  qs = zfdig->text();
  zf[4] = qs.toDouble(&ok);
  qs = zfdigr->text();
  zf[5] = qs.toDouble(&ok);

  index = 10; //Ab Adresse 10 stehen die ZF Frequenzen
  for(i=0;i<6;i++){
    c[3] = 0;
    if(zf[i] >= dkonst24){
      c[3] = char(zf[i] / dkonst24);
      zf[i] = zf[i] - (dkonst24 * double(c[3]));
    }
    c[2] = 0;
    if(zf[i] >= dkonst16){
      c[2] = char(zf[i] / dkonst16);
      zf[i] = zf[i] - (dkonst16 * double(c[2]));
    }
    c[1] = 0;
    if(zf[i] >= dkonst8){
      c[1] = char(zf[i] / dkonst8);
      zf[i] = zf[i] - (dkonst8 * double(c[1]));
    }
    c[0] = char(zf[i]);
    eeprombuffer[index] = c[0];
    eeprombuffer[index+1] = c[1];
    eeprombuffer[index+2] = c[2];
    eeprombuffer[index+3] = c[3];
    index = index + 4;
  }
  
  qs = edvfoamess->text(); vfoa[0] = qs.toDouble(&ok);
  qs = edvfobmess->text(); vfob[0] = qs.toDouble(&ok);
  qs = edvfoa160m->text(); vfoa[1] = qs.toDouble(&ok);
  qs = edvfob160m->text(); vfob[1] = qs.toDouble(&ok);
  qs = edvfoa80m->text(); vfoa[2] = qs.toDouble(&ok);
  qs = edvfob80m->text(); vfob[2] = qs.toDouble(&ok);
  qs = edvfoa60m->text(); vfoa[3] = qs.toDouble(&ok);
  qs = edvfob60m->text(); vfob[3] = qs.toDouble(&ok);
  qs = edvfoa40m->text(); vfoa[4] = qs.toDouble(&ok);
  qs = edvfob40m->text(); vfob[4] = qs.toDouble(&ok);
  qs = edvfoa30m->text(); vfoa[5] = qs.toDouble(&ok);
  qs = edvfob30m->text(); vfob[5] = qs.toDouble(&ok);
  qs = edvfoa20m->text(); vfoa[6] = qs.toDouble(&ok);
  qs = edvfob20m->text(); vfob[6] = qs.toDouble(&ok);
  qs = edvfoa17m->text(); vfoa[7] = qs.toDouble(&ok);
  qs = edvfob17m->text(); vfob[7] = qs.toDouble(&ok);
  qs = edvfoa15m->text(); vfoa[8] = qs.toDouble(&ok);
  qs = edvfob15m->text(); vfob[8] = qs.toDouble(&ok);
  qs = edvfoa12m->text(); vfoa[9] = qs.toDouble(&ok);
  qs = edvfob12m->text(); vfob[9] = qs.toDouble(&ok);
  qs = edvfoa10m->text(); vfoa[10] = qs.toDouble(&ok);
  qs = edvfob10m->text(); vfob[10] = qs.toDouble(&ok);
  qs = edvfoa6m->text(); vfoa[11] = qs.toDouble(&ok);
  qs = edvfob6m->text(); vfob[11] = qs.toDouble(&ok);
  qs = edvfoa2m->text(); vfoa[12] = qs.toDouble(&ok);
  qs = edvfob2m->text(); vfob[12] = qs.toDouble(&ok);
  bmzf[1] = mzf160m->isChecked();
  bmzf[2] = mzf80m->isChecked();
  bmzf[3] = mzf60m->isChecked();
  bmzf[4] = mzf40m->isChecked();
  bmzf[5] = mzf30m->isChecked();
  bmzf[6] = mzf20m->isChecked();
  bmzf[7] = mzf17m->isChecked();
  bmzf[8] = mzf15m->isChecked();
  bmzf[9] = mzf12m->isChecked();
  bmzf[10] = mzf10m->isChecked();
  bmzf[11] = mzf6m->isChecked();
  bmzf[12] = mzf2m->isChecked();
  modea[0] = 0; 
  modeb[0] = 0; 
  if(cwa160m->isChecked())modea[1] = 1; 
  if(cwb160m->isChecked())modeb[1] = 1; 
  if(cwra160m->isChecked())modea[1] = 2; 
  if(cwrb160m->isChecked())modeb[1] = 2; 
  if(lsba160m->isChecked())modea[1] = 3; 
  if(lsbb160m->isChecked())modeb[1] = 3; 
  if(usba160m->isChecked())modea[1] = 4; 
  if(usbb160m->isChecked())modeb[1] = 4; 
  if(diga160m->isChecked())modea[1] = 5; 
  if(digb160m->isChecked())modeb[1] = 5; 
  if(digra160m->isChecked())modea[1] = 6; 
  if(digrb160m->isChecked())modeb[1] = 6; 
  if(mzf160m->isChecked())modea[1] = modea[1] + 128; 
  if(cwa80m->isChecked())modea[2] = 1; 
  if(cwb80m->isChecked())modeb[2] = 1; 
  if(cwra80m->isChecked())modea[2] = 2; 
  if(cwrb80m->isChecked())modeb[2] = 2; 
  if(lsba80m->isChecked())modea[2] = 3; 
  if(lsbb80m->isChecked())modeb[2] = 3; 
  if(usba80m->isChecked())modea[2] = 4; 
  if(usbb80m->isChecked())modeb[2] = 4; 
  if(diga80m->isChecked())modea[2] = 5; 
  if(digb80m->isChecked())modeb[2] = 5; 
  if(digra80m->isChecked())modea[2] = 6; 
  if(digrb80m->isChecked())modeb[2] = 6; 
  if(mzf80m->isChecked())modea[2] = modea[2] + 128; 
  if(cwa60m->isChecked())modea[3] = 1; 
  if(cwb60m->isChecked())modeb[3] = 1; 
  if(cwra60m->isChecked())modea[3] = 2; 
  if(cwrb60m->isChecked())modeb[3] = 2; 
  if(lsba60m->isChecked())modea[3] = 3; 
  if(lsbb60m->isChecked())modeb[3] = 3; 
  if(usba60m->isChecked())modea[3] = 4; 
  if(usbb60m->isChecked())modeb[3] = 4; 
  if(diga60m->isChecked())modea[3] = 5; 
  if(digb60m->isChecked())modeb[3] = 5; 
  if(digra60m->isChecked())modea[3] = 6; 
  if(digrb60m->isChecked())modeb[3] = 6; 
  if(mzf60m->isChecked())modea[3] = modea[3] + 128; 
  if(cwa40m->isChecked())modea[4] = 1; 
  if(cwb40m->isChecked())modeb[4] = 1; 
  if(cwra40m->isChecked())modea[4] = 2; 
  if(cwrb40m->isChecked())modeb[4] = 2; 
  if(lsba40m->isChecked())modea[4] = 3; 
  if(lsbb40m->isChecked())modeb[4] = 3; 
  if(usba40m->isChecked())modea[4] = 4; 
  if(usbb40m->isChecked())modeb[4] = 4; 
  if(diga40m->isChecked())modea[4] = 5; 
  if(digb40m->isChecked())modeb[4] = 5; 
  if(digra40m->isChecked())modea[4] = 6; 
  if(digrb40m->isChecked())modeb[4] = 6; 
  if(mzf40m->isChecked())modea[4] = modea[4] + 128; 
  if(cwa30m->isChecked())modea[5] = 1; 
  if(cwb30m->isChecked())modeb[5] = 1; 
  if(cwra30m->isChecked())modea[5] = 2; 
  if(cwrb30m->isChecked())modeb[5] = 2; 
  if(lsba30m->isChecked())modea[5] = 3; 
  if(lsbb30m->isChecked())modeb[5] = 3; 
  if(usba30m->isChecked())modea[5] = 4; 
  if(usbb30m->isChecked())modeb[5] = 4; 
  if(diga30m->isChecked())modea[5] = 5; 
  if(digb30m->isChecked())modeb[5] = 5; 
  if(digra30m->isChecked())modea[5] = 6; 
  if(digrb30m->isChecked())modeb[5] = 6; 
  if(mzf30m->isChecked())modea[5] = modea[5] + 128; 
  if(cwa20m->isChecked())modea[6] = 1; 
  if(cwb20m->isChecked())modeb[6] = 1; 
  if(cwra20m->isChecked())modea[6] = 2; 
  if(cwrb20m->isChecked())modeb[6] = 2; 
  if(lsba20m->isChecked())modea[6] = 3; 
  if(lsbb20m->isChecked())modeb[6] = 3; 
  if(usba20m->isChecked())modea[6] = 4; 
  if(usbb20m->isChecked())modeb[6] = 4; 
  if(diga20m->isChecked())modea[6] = 5; 
  if(digb20m->isChecked())modeb[6] = 5; 
  if(digra20m->isChecked())modea[6] = 6; 
  if(digrb20m->isChecked())modeb[6] = 6; 
  if(mzf20m->isChecked())modea[6] = modea[6] + 128; 
  if(cwa17m->isChecked())modea[7] = 1; 
  if(cwb17m->isChecked())modeb[7] = 1; 
  if(cwra17m->isChecked())modea[7] = 2; 
  if(cwrb17m->isChecked())modeb[7] = 2; 
  if(lsba17m->isChecked())modea[7] = 3; 
  if(lsbb17m->isChecked())modeb[7] = 3; 
  if(usba17m->isChecked())modea[7] = 4; 
  if(usbb17m->isChecked())modeb[7] = 4; 
  if(diga17m->isChecked())modea[7] = 5; 
  if(digb17m->isChecked())modeb[7] = 5; 
  if(digra17m->isChecked())modea[7] = 6; 
  if(digrb17m->isChecked())modeb[7] = 6; 
  if(mzf17m->isChecked())modea[7] = modea[7] + 128; 
  if(cwa15m->isChecked())modea[8] = 1; 
  if(cwb15m->isChecked())modeb[8] = 1; 
  if(cwra15m->isChecked())modea[8] = 2; 
  if(cwrb15m->isChecked())modeb[8] = 2; 
  if(lsba15m->isChecked())modea[8] = 3; 
  if(lsbb15m->isChecked())modeb[8] = 3; 
  if(usba15m->isChecked())modea[8] = 4; 
  if(usbb15m->isChecked())modeb[8] = 4; 
  if(diga15m->isChecked())modea[8] = 5; 
  if(digb15m->isChecked())modeb[8] = 5; 
  if(digra15m->isChecked())modea[8] = 6; 
  if(digrb15m->isChecked())modeb[8] = 6; 
  if(mzf15m->isChecked())modea[8] = modea[8] + 128; 
  if(cwa12m->isChecked())modea[9] = 1; 
  if(cwb12m->isChecked())modeb[9] = 1; 
  if(cwra12m->isChecked())modea[9] = 2; 
  if(cwrb12m->isChecked())modeb[9] = 2; 
  if(lsba12m->isChecked())modea[9] = 3; 
  if(lsbb12m->isChecked())modeb[9] = 3; 
  if(usba12m->isChecked())modea[9] = 4; 
  if(usbb12m->isChecked())modeb[9] = 4; 
  if(diga12m->isChecked())modea[9] = 5; 
  if(digb12m->isChecked())modeb[9] = 5; 
  if(digra12m->isChecked())modea[9] = 6; 
  if(digrb12m->isChecked())modeb[9] = 6; 
  if(mzf12m->isChecked())modea[9] = modea[9] + 128; 
  if(cwa10m->isChecked())modea[10] = 1; 
  if(cwb10m->isChecked())modeb[10] = 1; 
  if(cwra10m->isChecked())modea[10] = 2; 
  if(cwrb10m->isChecked())modeb[10] = 2; 
  if(lsba10m->isChecked())modea[10] = 3; 
  if(lsbb10m->isChecked())modeb[10] = 3; 
  if(usba10m->isChecked())modea[10] = 4; 
  if(usbb10m->isChecked())modeb[10] = 4; 
  if(diga10m->isChecked())modea[10] = 5; 
  if(digb10m->isChecked())modeb[10] = 5; 
  if(digra10m->isChecked())modea[10] = 6; 
  if(digrb10m->isChecked())modeb[10] = 6; 
  if(mzf10m->isChecked())modea[10] = modea[10] + 128; 
  if(cwa6m->isChecked())modea[11] = 1; 
  if(cwb6m->isChecked())modeb[11] = 1; 
  if(cwra6m->isChecked())modea[11] = 2; 
  if(cwrb6m->isChecked())modeb[11] = 2; 
  if(lsba6m->isChecked())modea[11] = 3; 
  if(lsbb6m->isChecked())modeb[11] = 3; 
  if(usba6m->isChecked())modea[11] = 4; 
  if(usbb6m->isChecked())modeb[11] = 4; 
  if(diga6m->isChecked())modea[11] = 5; 
  if(digb6m->isChecked())modeb[11] = 5; 
  if(digra6m->isChecked())modea[11] = 6; 
  if(digrb6m->isChecked())modeb[11] = 6; 
  if(mzf6m->isChecked())modea[11] = modea[11] + 128; 
  if(cwa2m->isChecked())modea[12] = 1; 
  if(cwb2m->isChecked())modeb[12] = 1; 
  if(cwra2m->isChecked())modea[12] = 2; 
  if(cwrb2m->isChecked())modeb[12] = 2; 
  if(lsba2m->isChecked())modea[12] = 3; 
  if(lsbb2m->isChecked())modeb[12] = 3; 
  if(usba2m->isChecked())modea[12] = 4; 
  if(usbb2m->isChecked())modeb[12] = 4; 
  if(diga2m->isChecked())modea[12] = 5; 
  if(digb2m->isChecked())modeb[12] = 5; 
  if(digra2m->isChecked())modea[12] = 6; 
  if(digrb2m->isChecked())modeb[12] = 6; 
  if(mzf2m->isChecked())modea[12] = modea[12] + 128; 
  
  qs = mton->text();
  zf[0] = qs.toDouble(&ok);
  //Mithoerton ist bei Version 101 um 4 Byte verschoben
  if(eversion == 100)eeprombuffer[38] = char(zf[0] / 10.0);
  if(eversion == 101)eeprombuffer[42] = char(zf[0] / 10.0);

  //Ab Adresse 40 oder 44, je nach Eepromversion stehen die VFO Frequenzen der Baender
  if(eversion == 100)index = 40;
  if(eversion == 101)index = 44;
  for(i=0;i<13;i++)
  {
    //VFO A
    c[3] = 0;
    if(vfoa[i] >= dkonst24){ c[3] = char(vfoa[i] / dkonst24); vfoa[i] = vfoa[i] - (dkonst24 * double(c[3])); }
    c[2] = 0;
    if(vfoa[i] >= dkonst16){ c[2] = char(vfoa[i] / dkonst16); vfoa[i] = vfoa[i] - (dkonst16 * double(c[2])); }
    c[1] = 0;
    if(vfoa[i] >= dkonst8){ c[1] = char(vfoa[i] / dkonst8); vfoa[i] = vfoa[i] - (dkonst8 * double(c[1])); }
    c[0] = char(vfoa[i]);
    eeprombuffer[index] = c[0]; 
    eeprombuffer[index+1] = c[1];
    eeprombuffer[index+2] = c[2];
    eeprombuffer[index+3] = c[3];
    //VFO B
    c[3] = 0;
    if(vfob[i] >= dkonst24){ c[3] = char(vfob[i] / dkonst24); vfob[i] = vfob[i] - (dkonst24 * double(c[3])); }
    c[2] = 0;
    if(vfob[i] >= dkonst16){ c[2] = char(vfob[i] / dkonst16); vfob[i] = vfob[i] - (dkonst16 * double(c[2])); }
    c[1] = 0;
    if(vfob[i] >= dkonst8){ c[1] = char(vfob[i] / dkonst8); vfob[i] = vfob[i] - (dkonst8 * double(c[1])); }
    c[0] = char(vfob[i]);
    eeprombuffer[index+4] = c[0]; 
    eeprombuffer[index+5] = c[1];
    eeprombuffer[index+6] = c[2];
    eeprombuffer[index+7] = c[3];
    //Mode A und B
    eeprombuffer[index+8] = modea[i];
    eeprombuffer[index+9] = modeb[i];
    index = index + 10;
  }
  qs = edvfoatv1->text(); vfoa[0] = qs.toDouble(&ok);
  qs = edvfobtv1->text(); vfob[0] = qs.toDouble(&ok);
  qs = edvfoatv2->text(); vfoa[1] = qs.toDouble(&ok);
  qs = edvfobtv2->text(); vfob[1] = qs.toDouble(&ok);
  qs = edvfoatv3->text(); vfoa[2] = qs.toDouble(&ok);
  qs = edvfobtv3->text(); vfob[2] = qs.toDouble(&ok);
  qs = edvfoatv4->text(); vfoa[3] = qs.toDouble(&ok);
  qs = edvfobtv4->text(); vfob[3] = qs.toDouble(&ok);
  qs = edvfoatv5->text(); vfoa[4] = qs.toDouble(&ok);
  qs = edvfobtv5->text(); vfob[4] = qs.toDouble(&ok);
  bmzf[0] = mzftv1->isChecked();
  bmzf[1] = mzftv2->isChecked();
  bmzf[2] = mzftv3->isChecked();
  bmzf[3] = mzftv4->isChecked();
  bmzf[4] = mzftv5->isChecked();
  if(cwatv1->isChecked())modea[0] = 1; 
  if(cwbtv1->isChecked())modeb[0] = 1; 
  if(cwratv1->isChecked())modea[0] = 2; 
  if(cwrbtv1->isChecked())modeb[0] = 2; 
  if(lsbatv1->isChecked())modea[0] = 3; 
  if(lsbbtv1->isChecked())modeb[0] = 3; 
  if(usbatv1->isChecked())modea[0] = 4; 
  if(usbbtv1->isChecked())modeb[0] = 4; 
  if(digatv1->isChecked())modea[0] = 5; 
  if(digbtv1->isChecked())modeb[0] = 5; 
  if(digratv1->isChecked())modea[0] = 6; 
  if(digrbtv1->isChecked())modeb[0] = 6; 
  if(mzftv1->isChecked())modea[0] = modea[0] + 128; 
  if(cwatv2->isChecked())modea[1] = 1; 
  if(cwbtv2->isChecked())modeb[1] = 1; 
  if(cwratv2->isChecked())modea[1] = 2; 
  if(cwrbtv2->isChecked())modeb[1] = 2; 
  if(lsbatv2->isChecked())modea[1] = 3; 
  if(lsbbtv2->isChecked())modeb[1] = 3; 
  if(usbatv2->isChecked())modea[1] = 4; 
  if(usbbtv2->isChecked())modeb[1] = 4; 
  if(digatv2->isChecked())modea[1] = 5; 
  if(digbtv2->isChecked())modeb[1] = 5; 
  if(digratv2->isChecked())modea[1] = 6; 
  if(digrbtv2->isChecked())modeb[1] = 6; 
  if(mzftv2->isChecked())modea[1] = modea[1] + 128; 
  if(cwatv3->isChecked())modea[2] = 1; 
  if(cwbtv3->isChecked())modeb[2] = 1; 
  if(cwratv3->isChecked())modea[2] = 2; 
  if(cwrbtv3->isChecked())modeb[2] = 2; 
  if(lsbatv3->isChecked())modea[2] = 3; 
  if(lsbbtv3->isChecked())modeb[2] = 3; 
  if(usbatv3->isChecked())modea[2] = 4; 
  if(usbbtv3->isChecked())modeb[2] = 4; 
  if(digatv3->isChecked())modea[2] = 5; 
  if(digbtv3->isChecked())modeb[2] = 5; 
  if(digratv3->isChecked())modea[2] = 6; 
  if(digrbtv3->isChecked())modeb[2] = 6; 
  if(mzftv3->isChecked())modea[2] = modea[2] + 128; 
  if(cwatv4->isChecked())modea[3] = 1; 
  if(cwbtv4->isChecked())modeb[3] = 1; 
  if(cwratv4->isChecked())modea[3] = 2; 
  if(cwrbtv4->isChecked())modeb[3] = 2; 
  if(lsbatv4->isChecked())modea[3] = 3; 
  if(lsbbtv4->isChecked())modeb[3] = 3; 
  if(usbatv4->isChecked())modea[3] = 4; 
  if(usbbtv4->isChecked())modeb[3] = 4; 
  if(digatv4->isChecked())modea[3] = 5; 
  if(digbtv4->isChecked())modeb[3] = 5; 
  if(digratv4->isChecked())modea[3] = 6; 
  if(digrbtv4->isChecked())modeb[3] = 6; 
  if(mzftv4->isChecked())modea[3] = modea[3] + 128; 
  if(cwatv5->isChecked())modea[4] = 1; 
  if(cwbtv5->isChecked())modeb[4] = 1; 
  if(cwratv5->isChecked())modea[4] = 2; 
  if(cwrbtv5->isChecked())modeb[4] = 2; 
  if(lsbatv5->isChecked())modea[4] = 3; 
  if(lsbbtv5->isChecked())modeb[4] = 3; 
  if(usbatv5->isChecked())modea[4] = 4; 
  if(usbbtv5->isChecked())modeb[4] = 4; 
  if(digatv5->isChecked())modea[4] = 5; 
  if(digbtv5->isChecked())modeb[4] = 5; 
  if(digratv5->isChecked())modea[4] = 6; 
  if(digrbtv5->isChecked())modeb[4] = 6; 
  if(mzftv5->isChecked())modea[4] = modea[4] + 128; 
  qs = shifttv1->text(); display[0] = qs.toDouble(&ok);
  qs = shifttv2->text(); display[1] = qs.toDouble(&ok);
  qs = shifttv3->text(); display[2] = qs.toDouble(&ok);
  qs = shifttv4->text(); display[3] = qs.toDouble(&ok);
  qs = shifttv5->text(); display[4] = qs.toDouble(&ok);
  
  for(i=0;i<5;i++)
  {
    c[3] = 0;
    if(vfoa[i] >= dkonst24){ c[3] = char(vfoa[i] / dkonst24); vfoa[i] = vfoa[i] - (dkonst24 * double(c[3])); }
    c[2] = 0;
    if(vfoa[i] >= dkonst16){ c[2] = char(vfoa[i] / dkonst16); vfoa[i] = vfoa[i] - (dkonst16 * double(c[2])); }
    c[1] = 0;
    if(vfoa[i] >= dkonst8){ c[1] = char(vfoa[i] / dkonst8); vfoa[i] = vfoa[i] - (dkonst8 * double(c[1])); }
    c[0] = char(vfoa[i]);
    eeprombuffer[index] = c[0]; 
    eeprombuffer[index+1] = c[1];
    eeprombuffer[index+2] = c[2];
    eeprombuffer[index+3] = c[3];
    c[3] = 0;
    if(vfob[i] >= dkonst24){ c[3] = char(vfob[i] / dkonst24); vfob[i] = vfob[i] - (dkonst24 * double(c[3])); }
    c[2] = 0;
    if(vfob[i] >= dkonst16){ c[2] = char(vfob[i] / dkonst16); vfob[i] = vfob[i] - (dkonst16 * double(c[2])); }
    c[1] = 0;
    if(vfob[i] >= dkonst8){ c[1] = char(vfob[i] / dkonst8); vfob[i] = vfob[i] - (dkonst8 * double(c[1])); }
    c[0] = char(vfob[i]);
    eeprombuffer[index+4] = c[0]; 
    eeprombuffer[index+5] = c[1];
    eeprombuffer[index+6] = c[2];
    eeprombuffer[index+7] = c[3];
    eeprombuffer[index+8] = modea[i];
    eeprombuffer[index+9] = modeb[i];
    c[4] = 0;
    if(display[i] >= dkonst32){ c[4] = char(display[i] / dkonst32); display[i] = display[i] - (dkonst32 * double(c[4])); }
    c[3] = 0;
    if(display[i] >= dkonst24){ c[3] = char(display[i] / dkonst24); display[i] = display[i] - (dkonst24 * double(c[3])); }
    c[2] = 0;
    if(display[i] >= dkonst16){ c[2] = char(display[i] / dkonst16); display[i] = display[i] - (dkonst16 * double(c[2])); }
    c[1] = 0;
    if(display[i] >= dkonst8){ c[1] = char(display[i] / dkonst8); display[i] = display[i] - (dkonst8 * double(c[1])); }
    c[0] = char(display[i]);
    eeprombuffer[index+10] = c[0]; 
    eeprombuffer[index+11] = c[1];
    eeprombuffer[index+12] = c[2];
    eeprombuffer[index+13] = c[3];
    eeprombuffer[index+14] = c[4];
    
    index = index + 16;
  }
  eeprombuffer[254] = 0;
  if(autostep->isChecked())eeprombuffer[254]+=1;
  eeprombuffer[255] = eversion;
}

void avfo::setDaten()
{
  QString qs;
  double dkonst32 = 4294967296.0;  // 2 hoch 32
  double dkonst28 = 268435456.0;  // 2 hoch 28
  double ddskonst;
  double ddstakt;
  double zf[6];
  double vfoa[13];
  double vfob[13];
  double display[5];
  bool bmzf[13];
  int modea[13];
  int modeb[13];
  int i;
  int index;
  double dsmx;
  double dsmy;
  
  for(i=0;i<256;i++)buffercopy[i] = eeprombuffer[i];
  //Eepromversion auslesen
  eversion = eeprombuffer[255];
  //zum debugen ausgeben
  qDebug("SetDaten-Eepromversion: %i",eversion);
  if(eversion == 100)version100->setChecked(true);
  if(eversion == 101)version101->setChecked(true);
  ddskonst = eeprombuffer[0] +
             eeprombuffer[1] * 256.0 + 
             eeprombuffer[2] * 256.0 * 256.0 + 
             eeprombuffer[3] * 256.0 * 256.0 * 256.0 + 
             eeprombuffer[4] * 256.0 * 256.0 * 256.0 * 256.0;
  //qDebug("%f", ddskonst);
  if(eeprombuffer[8]==0){
    ddstakt = dkonst32 * dkonst28 / ddskonst;
  }else{
    ddstakt = dkonst32 * dkonst32 / ddskonst;
  } 
  //qDebug("%f", ddstakt);
  qs.sprintf("%1.0f",ddstakt);
  edddstakt->setText(qs);
  index = 10;
  for(i=0;i<6;i++){
    zf[i] = eeprombuffer[index] + 
            eeprombuffer[index+1] * 256.0 + 
            eeprombuffer[index+2] * 256.0 * 256.0 + 
            eeprombuffer[index+3] * 256.0 * 256.0 * 256.0;
    index = index + 4;
    //qDebug("%i %f", i, zf[i]);
  }
  qs.sprintf("%1.0f",zf[0]);
  zfcw->setText(qs);
  qs.sprintf("%1.0f",zf[1]);
  zfcwr->setText(qs);
  qs.sprintf("%1.0f",zf[2]);
  zflsb->setText(qs);
  qs.sprintf("%1.0f",zf[3]);
  zfusb->setText(qs);
  qs.sprintf("%1.0f",zf[4]);
  zfdig->setText(qs);
  qs.sprintf("%1.0f",zf[5]);
  zfdigr->setText(qs);
  switch(eeprombuffer[8]){
    case 0: ad9833->setChecked(TRUE); break; 
    case 1: ad9850->setChecked(TRUE); break; 
    case 2: ad9851->setChecked(TRUE); break; 
    case 3: ad9951_1->setChecked(TRUE); break; 
    case 4: ad9951_2->setChecked(TRUE); break; 
    case 5: ad9951_3->setChecked(TRUE); break; 
    case 6: ad9951_4->setChecked(TRUE); break; 
  }
  i = eeprombuffer[7];
  if(i > 127){ i = i - 128; vfox4->setChecked(TRUE); }
  if(i > 63){ i = i - 64; bandmodeum->setChecked(TRUE); }
  if(i > 31){ i = i - 32; sendenohnezf->setChecked(TRUE); }
  if(i > 15){ i = i - 16; keyer->setChecked(TRUE); }
  if(i > 7){ i = i - 8; c1hz->setChecked(TRUE); }
  if(i > 3){ i = i - 4; autolicht->setChecked(TRUE); }
  if(i > 1){ i = i - 2; dauerlicht->setChecked(TRUE); }
  if(i == 1){ smeter->setChecked(TRUE); }
  i = eeprombuffer[9];
  txhang->setValue(i*5);
  i = eeprombuffer[254];
  if(i == 1){ autostep->setChecked(TRUE); }

  index = 34;
  if(eversion == 100){
    dsmx = double(eeprombuffer[index] + (eeprombuffer[index+1] * 256));
    dsmy = double(eeprombuffer[index+2] + (eeprombuffer[index+3] * 256));
  }
  if(eversion == 101){
    dsmx = double(eeprombuffer[index] +
                  eeprombuffer[index+1] * 256.0 +
                  eeprombuffer[index+2] * 256.0 * 256.0 +
                  eeprombuffer[index+3] * 256.0 * 256.0 * 256.0);
    dsmy = double(eeprombuffer[index+4] +
                  eeprombuffer[index+5] * 256.0 +
                  eeprombuffer[index+6] * 256.0 * 256.0 +
                  eeprombuffer[index+7] * 256.0 * 256.0 * 256.0);
  }
  qs.sprintf("%f",dsmx);
  smx->setText(qs);
  qs.sprintf("%f",dsmy);
  smy->setText(qs);
  if(eversion == 100){
    dsmx = double(eeprombuffer[index+4] * 10);
  }
  if(eversion == 101){
    dsmx = double(eeprombuffer[index+4+4] * 10);
  }
  qs.sprintf("%1.0f",dsmx);
  mton->setText(qs);
  if(eversion == 100){
    index = 40;
  }
  if(eversion == 101){
    index = 44;
  }
  for(i=0;i<13;i++)
  {
    vfoa[i] = eeprombuffer[index] + 
              eeprombuffer[index+1] * 256.0 + 
              eeprombuffer[index+2] * 256.0 * 256.0 + 
              eeprombuffer[index+3] * 256.0 * 256.0 * 256.0;
    vfob[i] = eeprombuffer[index+4] + 
              eeprombuffer[index+5] * 256.0 + 
              eeprombuffer[index+6] * 256.0 * 256.0 + 
              eeprombuffer[index+7] * 256.0 * 256.0 * 256.0;
    modea[i] = eeprombuffer[index+8];
    modeb[i] = eeprombuffer[index+9];
    bmzf[i] = FALSE;
    if(modea[i] > 127){modea[i] = modea[i] - 128; bmzf[i] = TRUE;}
    index = index + 10;
  }
  qs.sprintf("%1.0f",vfoa[0]); edvfoamess->setText(qs);
  qs.sprintf("%1.0f",vfob[0]); edvfobmess->setText(qs);
  qs.sprintf("%1.0f",vfoa[1]); edvfoa160m->setText(qs);
  qs.sprintf("%1.0f",vfob[1]); edvfob160m->setText(qs);
  qs.sprintf("%1.0f",vfoa[2]); edvfoa80m->setText(qs);
  qs.sprintf("%1.0f",vfob[2]); edvfob80m->setText(qs);
  qs.sprintf("%1.0f",vfoa[3]); edvfoa60m->setText(qs);
  qs.sprintf("%1.0f",vfob[3]); edvfob60m->setText(qs);
  qs.sprintf("%1.0f",vfoa[4]); edvfoa40m->setText(qs);
  qs.sprintf("%1.0f",vfob[4]); edvfob40m->setText(qs);
  qs.sprintf("%1.0f",vfoa[5]); edvfoa30m->setText(qs);
  qs.sprintf("%1.0f",vfob[5]); edvfob30m->setText(qs);
  qs.sprintf("%1.0f",vfoa[6]); edvfoa20m->setText(qs);
  qs.sprintf("%1.0f",vfob[6]); edvfob20m->setText(qs);
  qs.sprintf("%1.0f",vfoa[7]); edvfoa17m->setText(qs);
  qs.sprintf("%1.0f",vfob[7]); edvfob17m->setText(qs);
  qs.sprintf("%1.0f",vfoa[8]); edvfoa15m->setText(qs);
  qs.sprintf("%1.0f",vfob[8]); edvfob15m->setText(qs);
  qs.sprintf("%1.0f",vfoa[9]); edvfoa12m->setText(qs);
  qs.sprintf("%1.0f",vfob[9]); edvfob12m->setText(qs);
  qs.sprintf("%1.0f",vfoa[10]); edvfoa10m->setText(qs);
  qs.sprintf("%1.0f",vfob[10]); edvfob10m->setText(qs);
  qs.sprintf("%1.0f",vfoa[11]); edvfoa6m->setText(qs);
  qs.sprintf("%1.0f",vfob[11]); edvfob6m->setText(qs);
  qs.sprintf("%1.0f",vfoa[12]); edvfoa2m->setText(qs);
  qs.sprintf("%1.0f",vfob[12]); edvfob2m->setText(qs);
  mzf160m->setChecked(bmzf[1]);
  mzf80m->setChecked(bmzf[2]);
  mzf60m->setChecked(bmzf[3]);
  mzf40m->setChecked(bmzf[4]);
  mzf30m->setChecked(bmzf[5]);
  mzf20m->setChecked(bmzf[6]);
  mzf17m->setChecked(bmzf[7]);
  mzf15m->setChecked(bmzf[8]);
  mzf12m->setChecked(bmzf[9]);
  mzf10m->setChecked(bmzf[10]);
  mzf6m->setChecked(bmzf[11]);
  mzf2m->setChecked(bmzf[12]);
  switch(modea[1]){
    case 1: cwa160m->setChecked(TRUE); break; 
    case 2: cwra160m->setChecked(TRUE); break; 
    case 3: lsba160m->setChecked(TRUE); break; 
    case 4: usba160m->setChecked(TRUE); break; 
    case 5: diga160m->setChecked(TRUE); break; 
    case 6: digra160m->setChecked(TRUE); break; 
  }
  switch(modeb[1]){
    case 1: cwb160m->setChecked(TRUE); break; 
    case 2: cwrb160m->setChecked(TRUE); break; 
    case 3: lsbb160m->setChecked(TRUE); break; 
    case 4: usbb160m->setChecked(TRUE); break; 
    case 5: digb160m->setChecked(TRUE); break; 
    case 6: digrb160m->setChecked(TRUE); break; 
  }
  switch(modea[2]){
    case 1: cwa80m->setChecked(TRUE); break; 
    case 2: cwra80m->setChecked(TRUE); break; 
    case 3: lsba80m->setChecked(TRUE); break; 
    case 4: usba80m->setChecked(TRUE); break; 
    case 5: diga80m->setChecked(TRUE); break; 
    case 6: digra80m->setChecked(TRUE); break; 
  }
  switch(modeb[2]){
    case 1: cwb80m->setChecked(TRUE); break; 
    case 2: cwrb80m->setChecked(TRUE); break; 
    case 3: lsbb80m->setChecked(TRUE); break; 
    case 4: usbb80m->setChecked(TRUE); break; 
    case 5: digb80m->setChecked(TRUE); break; 
    case 6: digrb80m->setChecked(TRUE); break; 
  }
  switch(modea[3]){
    case 1: cwa60m->setChecked(TRUE); break; 
    case 2: cwra60m->setChecked(TRUE); break; 
    case 3: lsba60m->setChecked(TRUE); break; 
    case 4: usba60m->setChecked(TRUE); break; 
    case 5: diga60m->setChecked(TRUE); break; 
    case 6: digra60m->setChecked(TRUE); break; 
  }
  switch(modeb[3]){
    case 1: cwb60m->setChecked(TRUE); break; 
    case 2: cwrb60m->setChecked(TRUE); break; 
    case 3: lsbb60m->setChecked(TRUE); break; 
    case 4: usbb60m->setChecked(TRUE); break; 
    case 5: digb60m->setChecked(TRUE); break; 
    case 6: digrb60m->setChecked(TRUE); break; 
  }
  switch(modea[4]){
    case 1: cwa40m->setChecked(TRUE); break; 
    case 2: cwra40m->setChecked(TRUE); break; 
    case 3: lsba40m->setChecked(TRUE); break; 
    case 4: usba40m->setChecked(TRUE); break; 
    case 5: diga40m->setChecked(TRUE); break; 
    case 6: digra40m->setChecked(TRUE); break; 
  }
  switch(modeb[4]){
    case 1: cwb40m->setChecked(TRUE); break; 
    case 2: cwrb40m->setChecked(TRUE); break; 
    case 3: lsbb40m->setChecked(TRUE); break; 
    case 4: usbb40m->setChecked(TRUE); break; 
    case 5: digb40m->setChecked(TRUE); break; 
    case 6: digrb40m->setChecked(TRUE); break; 
  }
  switch(modea[5]){
    case 1: cwa30m->setChecked(TRUE); break; 
    case 2: cwra30m->setChecked(TRUE); break; 
    case 3: lsba30m->setChecked(TRUE); break; 
    case 4: usba30m->setChecked(TRUE); break; 
    case 5: diga30m->setChecked(TRUE); break; 
    case 6: digra30m->setChecked(TRUE); break; 
  }
  switch(modeb[5]){
    case 1: cwb30m->setChecked(TRUE); break; 
    case 2: cwrb30m->setChecked(TRUE); break; 
    case 3: lsbb30m->setChecked(TRUE); break; 
    case 4: usbb30m->setChecked(TRUE); break; 
    case 5: digb30m->setChecked(TRUE); break; 
    case 6: digrb30m->setChecked(TRUE); break; 
  }
  switch(modea[6]){
    case 1: cwa20m->setChecked(TRUE); break; 
    case 2: cwra20m->setChecked(TRUE); break; 
    case 3: lsba20m->setChecked(TRUE); break; 
    case 4: usba20m->setChecked(TRUE); break; 
    case 5: diga20m->setChecked(TRUE); break; 
    case 6: digra20m->setChecked(TRUE); break; 
  }
  switch(modeb[6]){
    case 1: cwb20m->setChecked(TRUE); break; 
    case 2: cwrb20m->setChecked(TRUE); break; 
    case 3: lsbb20m->setChecked(TRUE); break; 
    case 4: usbb20m->setChecked(TRUE); break; 
    case 5: digb20m->setChecked(TRUE); break; 
    case 6: digrb20m->setChecked(TRUE); break; 
  }
  switch(modea[7]){
    case 1: cwa17m->setChecked(TRUE); break; 
    case 2: cwra17m->setChecked(TRUE); break; 
    case 3: lsba17m->setChecked(TRUE); break; 
    case 4: usba17m->setChecked(TRUE); break; 
    case 5: diga17m->setChecked(TRUE); break; 
    case 6: digra17m->setChecked(TRUE); break; 
  }
  switch(modeb[7]){
    case 1: cwb17m->setChecked(TRUE); break; 
    case 2: cwrb17m->setChecked(TRUE); break; 
    case 3: lsbb17m->setChecked(TRUE); break; 
    case 4: usbb17m->setChecked(TRUE); break; 
    case 5: digb17m->setChecked(TRUE); break; 
    case 6: digrb17m->setChecked(TRUE); break; 
  }
  switch(modea[8]){
    case 1: cwa15m->setChecked(TRUE); break; 
    case 2: cwra15m->setChecked(TRUE); break; 
    case 3: lsba15m->setChecked(TRUE); break; 
    case 4: usba15m->setChecked(TRUE); break; 
    case 5: diga15m->setChecked(TRUE); break; 
    case 6: digra15m->setChecked(TRUE); break; 
  }
  switch(modeb[8]){
    case 1: cwb15m->setChecked(TRUE); break; 
    case 2: cwrb15m->setChecked(TRUE); break; 
    case 3: lsbb15m->setChecked(TRUE); break; 
    case 4: usbb15m->setChecked(TRUE); break; 
    case 5: digb15m->setChecked(TRUE); break; 
    case 6: digrb15m->setChecked(TRUE); break; 
  }
  switch(modea[9]){
    case 1: cwa12m->setChecked(TRUE); break; 
    case 2: cwra12m->setChecked(TRUE); break; 
    case 3: lsba12m->setChecked(TRUE); break; 
    case 4: usba12m->setChecked(TRUE); break; 
    case 5: diga12m->setChecked(TRUE); break; 
    case 6: digra12m->setChecked(TRUE); break; 
  }
  switch(modeb[9]){
    case 1: cwb12m->setChecked(TRUE); break; 
    case 2: cwrb12m->setChecked(TRUE); break; 
    case 3: lsbb12m->setChecked(TRUE); break; 
    case 4: usbb12m->setChecked(TRUE); break; 
    case 5: digb12m->setChecked(TRUE); break; 
    case 6: digrb12m->setChecked(TRUE); break; 
  }
  switch(modea[10]){
    case 1: cwa10m->setChecked(TRUE); break; 
    case 2: cwra10m->setChecked(TRUE); break; 
    case 3: lsba10m->setChecked(TRUE); break; 
    case 4: usba10m->setChecked(TRUE); break; 
    case 5: diga10m->setChecked(TRUE); break; 
    case 6: digra10m->setChecked(TRUE); break; 
  }
  switch(modeb[10]){
    case 1: cwb10m->setChecked(TRUE); break; 
    case 2: cwrb10m->setChecked(TRUE); break; 
    case 3: lsbb10m->setChecked(TRUE); break; 
    case 4: usbb10m->setChecked(TRUE); break; 
    case 5: digb10m->setChecked(TRUE); break; 
    case 6: digrb10m->setChecked(TRUE); break; 
  }
  switch(modea[11]){
    case 1: cwa6m->setChecked(TRUE); break; 
    case 2: cwra6m->setChecked(TRUE); break; 
    case 3: lsba6m->setChecked(TRUE); break; 
    case 4: usba6m->setChecked(TRUE); break; 
    case 5: diga6m->setChecked(TRUE); break; 
    case 6: digra6m->setChecked(TRUE); break; 
  }
  switch(modeb[11]){
    case 1: cwb6m->setChecked(TRUE); break; 
    case 2: cwrb6m->setChecked(TRUE); break; 
    case 3: lsbb6m->setChecked(TRUE); break; 
    case 4: usbb6m->setChecked(TRUE); break; 
    case 5: digb6m->setChecked(TRUE); break; 
    case 6: digrb6m->setChecked(TRUE); break; 
  }
  switch(modea[12]){
    case 1: cwa2m->setChecked(TRUE); break; 
    case 2: cwra2m->setChecked(TRUE); break; 
    case 3: lsba2m->setChecked(TRUE); break; 
    case 4: usba2m->setChecked(TRUE); break; 
    case 5: diga2m->setChecked(TRUE); break; 
    case 6: digra2m->setChecked(TRUE); break; 
  }
  switch(modeb[12]){
    case 1: cwb2m->setChecked(TRUE); break; 
    case 2: cwrb2m->setChecked(TRUE); break; 
    case 3: lsbb2m->setChecked(TRUE); break; 
    case 4: usbb2m->setChecked(TRUE); break; 
    case 5: digb2m->setChecked(TRUE); break; 
    case 6: digrb2m->setChecked(TRUE); break; 
  }
  for(i=0;i<5;i++)
  {
    vfoa[i] = eeprombuffer[index] + 
              eeprombuffer[index+1] * 256.0 + 
              eeprombuffer[index+2] * 256.0 * 256.0 + 
              eeprombuffer[index+3] * 256.0 * 256.0 * 256.0;
    vfob[i] = eeprombuffer[index+4] + 
              eeprombuffer[index+5] * 256.0 + 
              eeprombuffer[index+6] * 256.0 * 256.0 + 
              eeprombuffer[index+7] * 256.0 * 256.0 * 256.0;
    modea[i] = eeprombuffer[index+8];
    modeb[i] = eeprombuffer[index+9];
    display[i] = eeprombuffer[index+10] + 
                 eeprombuffer[index+11] * 256.0 + 
                 eeprombuffer[index+12] * 256.0 * 256.0 + 
                 eeprombuffer[index+13] * 256.0 * 256.0 * 256.0 +
                 eeprombuffer[index+14] * 256.0 * 256.0 * 256.0 * 256.0;
    bmzf[i] = FALSE;
    if(modea[i] > 127){modea[i] = modea[i] - 128; bmzf[i] = TRUE;}
    index = index + 16;
  }
  qs.sprintf("%1.0f",vfoa[0]); edvfoatv1->setText(qs);
  qs.sprintf("%1.0f",vfob[0]); edvfobtv1->setText(qs);
  qs.sprintf("%1.0f",vfoa[1]); edvfoatv2->setText(qs);
  qs.sprintf("%1.0f",vfob[1]); edvfobtv2->setText(qs);
  qs.sprintf("%1.0f",vfoa[2]); edvfoatv3->setText(qs);
  qs.sprintf("%1.0f",vfob[2]); edvfobtv3->setText(qs);
  qs.sprintf("%1.0f",vfoa[3]); edvfoatv4->setText(qs);
  qs.sprintf("%1.0f",vfob[3]); edvfobtv4->setText(qs);
  qs.sprintf("%1.0f",vfoa[4]); edvfoatv5->setText(qs);
  qs.sprintf("%1.0f",vfob[4]); edvfobtv5->setText(qs);
  qs.sprintf("%1.0f",display[0]); shifttv1->setText(qs);
  qs.sprintf("%1.0f",display[1]); shifttv2->setText(qs);
  qs.sprintf("%1.0f",display[2]); shifttv3->setText(qs);
  qs.sprintf("%1.0f",display[3]); shifttv4->setText(qs);
  qs.sprintf("%1.0f",display[4]); shifttv5->setText(qs);
  qs.sprintf("%1.0f",display[0]+vfoa[0]); frqtv1->setText(qs);
  qs.sprintf("%1.0f",display[1]+vfoa[1]); frqtv2->setText(qs);
  qs.sprintf("%1.0f",display[2]+vfoa[2]); frqtv3->setText(qs);
  qs.sprintf("%1.0f",display[3]+vfoa[3]); frqtv4->setText(qs);
  qs.sprintf("%1.0f",display[4]+vfoa[4]); frqtv5->setText(qs);
  switch(modea[0]){
    case 1: cwatv1->setChecked(TRUE); break; 
    case 2: cwratv1->setChecked(TRUE); break; 
    case 3: lsbatv1->setChecked(TRUE); break; 
    case 4: usbatv1->setChecked(TRUE); break; 
    case 5: digatv1->setChecked(TRUE); break; 
    case 6: digratv1->setChecked(TRUE); break; 
  }
  switch(modeb[0]){
    case 1: cwbtv1->setChecked(TRUE); break; 
    case 2: cwrbtv1->setChecked(TRUE); break; 
    case 3: lsbbtv1->setChecked(TRUE); break; 
    case 4: usbbtv1->setChecked(TRUE); break; 
    case 5: digbtv1->setChecked(TRUE); break; 
    case 6: digrbtv1->setChecked(TRUE); break; 
  }
  switch(modea[1]){
    case 1: cwatv2->setChecked(TRUE); break; 
    case 2: cwratv2->setChecked(TRUE); break; 
    case 3: lsbatv2->setChecked(TRUE); break; 
    case 4: usbatv2->setChecked(TRUE); break; 
    case 5: digatv2->setChecked(TRUE); break; 
    case 6: digratv2->setChecked(TRUE); break; 
  }
  switch(modeb[1]){
    case 1: cwbtv2->setChecked(TRUE); break; 
    case 2: cwrbtv2->setChecked(TRUE); break; 
    case 3: lsbbtv2->setChecked(TRUE); break; 
    case 4: usbbtv2->setChecked(TRUE); break; 
    case 5: digbtv2->setChecked(TRUE); break; 
    case 6: digrbtv2->setChecked(TRUE); break; 
  }
  switch(modea[2]){
    case 1: cwatv3->setChecked(TRUE); break; 
    case 2: cwratv3->setChecked(TRUE); break; 
    case 3: lsbatv3->setChecked(TRUE); break; 
    case 4: usbatv3->setChecked(TRUE); break; 
    case 5: digatv3->setChecked(TRUE); break; 
    case 6: digratv3->setChecked(TRUE); break; 
  }
  switch(modeb[2]){
    case 1: cwbtv3->setChecked(TRUE); break; 
    case 2: cwrbtv3->setChecked(TRUE); break; 
    case 3: lsbbtv3->setChecked(TRUE); break; 
    case 4: usbbtv3->setChecked(TRUE); break; 
    case 5: digbtv3->setChecked(TRUE); break; 
    case 6: digrbtv3->setChecked(TRUE); break; 
  }
  switch(modea[3]){
    case 1: cwatv4->setChecked(TRUE); break; 
    case 2: cwratv4->setChecked(TRUE); break; 
    case 3: lsbatv4->setChecked(TRUE); break; 
    case 4: usbatv4->setChecked(TRUE); break; 
    case 5: digatv4->setChecked(TRUE); break; 
    case 6: digratv4->setChecked(TRUE); break; 
  }
  switch(modeb[3]){
    case 1: cwbtv4->setChecked(TRUE); break; 
    case 2: cwrbtv4->setChecked(TRUE); break; 
    case 3: lsbbtv4->setChecked(TRUE); break; 
    case 4: usbbtv4->setChecked(TRUE); break; 
    case 5: digbtv4->setChecked(TRUE); break; 
    case 6: digrbtv4->setChecked(TRUE); break; 
  }
  switch(modea[4]){
    case 1: cwatv5->setChecked(TRUE); break; 
    case 2: cwratv5->setChecked(TRUE); break; 
    case 3: lsbatv5->setChecked(TRUE); break; 
    case 4: usbatv5->setChecked(TRUE); break; 
    case 5: digatv5->setChecked(TRUE); break; 
    case 6: digratv5->setChecked(TRUE); break; 
  }
  switch(modeb[4]){
    case 1: cwbtv5->setChecked(TRUE); break; 
    case 2: cwrbtv5->setChecked(TRUE); break; 
    case 3: lsbbtv5->setChecked(TRUE); break; 
    case 4: usbbtv5->setChecked(TRUE); break; 
    case 5: digbtv5->setChecked(TRUE); break; 
    case 6: digrbtv5->setChecked(TRUE); break; 
  }
  mzftv1->setChecked(bmzf[0]);
  mzftv2->setChecked(bmzf[1]);
  mzftv3->setChecked(bmzf[2]);
  mzftv4->setChecked(bmzf[3]);
  mzftv5->setChecked(bmzf[4]);
  awidget->setEnabled(TRUE);
  saveAct->setEnabled(TRUE);
  picschreibenAct->setEnabled(TRUE);
}

void avfo::open()
{
  QFile f;
  int i;
  uint j;
  
  QString s = QFileDialog::getOpenFileName(
              this
              ,tr("Datendatei fuer den VFO Laden","FileDialog")
              ,""
              ,tr("Datendatei fuer den VFO (*.vfo)","FileDialog")
              );
  if (!s.isNull())
  {
    f.setFileName(s);
    if(f.open( QIODevice::ReadOnly )){
      QDataStream ts(&f);
      for(i=0; i<256; i++)
      {  
        j = eeprombuffer[i];
        ts >> j;
        eeprombuffer[i] = j;
        //qDebug("BYTENR %i  BYTE %x",i, eeprombuffer[i]);
      }
    }
    setDaten();
  }
}

void avfo::rs232einstellen()
{
  bool ok;
  
//QString getText ( QWidget * parent, const QString & title, const QString & label, QLineEdit::EchoMode mode = QLineEdit::Normal, const QString & text = QString(), bool * ok = 0, Qt::WindowFlags f = 0 )
  srs232 = QInputDialog::getText(this, tr("RS232","in InputBox"), tr("Einstellen der seriellen Schnittstelle"),
                                 QLineEdit::Normal,
                                 srs232, &ok);
  if(ok){
    picmodem->closetty();
    rs232isopen = picmodem->opentty(srs232);
    if(!rs232isopen){
      QMessageBox::about(this, tr("RS232"),tr("Die RS232 ist nicht offen!"));
    }
  }
}

void avfo::setAText(QString stty){
  QString qs;
  qs = "Allband-VFO";
  QString astty = qs + " - " + version + " - " + stty;
  setWindowTitle(astty);
}

void avfo::save()
{
  QFile f;
  int i;
  uint j;
  
  getDaten();
  QString s = QFileDialog::getSaveFileName(
              this
              ,tr("Datendatei fuer den VFO Schreiben","FileDialog")
              ,""
              ,tr("Datendatei fuer den VFO (*.vfo)","FileDialog")
              );
  if (!s.isNull())
  {
    if(!(s.contains(".vfo", Qt::CaseInsensitive))) s += ".vfo";
    f.setFileName(s);
    if(f.open( QIODevice::WriteOnly))
    {
      QDataStream ts(&f);
      for(i=0; i<256; i++)
      {
        j = eeprombuffer[i];
        ts << j;
      }
    }
  }
}

void avfo::picpdcancel()
{
  pic2pctimer->stop();
  pc2pictimer->stop();
  picpd->setValue(256);
}

void avfo::pc2pictimerstop()
{
  unsigned char c;
  
  c = eeprombuffer[eecounter];
//  qDebug("BYTENR %i  BYTE %x",eecounter, eeprombuffer[eecounter]);
  picmodem->writeChar(c);
  eecounter++;
  if(eecounter == 256){
    pc2pictimer->stop();
  }else{
    pc2pictimer->start(10);
  }
  picpd->setValue(eecounter);
}

void avfo::pic2pctimerstop()
{
  uint c;
  int i;
  i = picmodem->readttybuffer(&c, 1);
  if(i == 1){
    eeprombuffer[eecounter] = c;
    //qDebug("BYTENR %i  BYTE %x",eecounter, eeprombuffer[eecounter]);
    eecounter++;
  }
  if(eecounter == 256){
    pic2pctimer->stop();
    setDaten();
  }else{
    pic2pctimer->start(0);
  }
  picpd->setValue(eecounter);
}

void avfo::closeEvent(QCloseEvent *event)
{
  writeSettings();
  event->accept();
}

void avfo::about()
{
  QString qs = 
            tr("Diese Applikation dient der "
               "Datensicherung aller Einstellungen "
               "des PICs vom AllbandVFO<br><br> ")
               +version+verdatum+"<br> (c) DL4JAL";
      
      QMessageBox::about(this, tr("Allband-VFO"), qs);
}

void avfo::displayshiftset1(QString qs){
  QString qs1, qs2, qs3;
  bool ok;
  double a, b, c;
  
  qs3 = qs;
  qs1 = shifttv1->text();
  a = qs1.toDouble(&ok); 
  qs2 = edvfoatv1->text();
  b = qs2.toDouble(&ok);
  qs3 = frqtv1->text();
  c = qs3.toDouble(&ok);
  a = c - b;
  qs1.sprintf("%11.0f", a);
  shifttv1->setText(qs1);
}

void avfo::displayshiftset2(QString qs){
  QString qs1, qs2, qs3;
  bool ok;
  double a, b, c;
  
  qs3 = qs;
  qs1 = shifttv2->text();
  a = qs1.toDouble(&ok); 
  qs2 = edvfoatv2->text();
  b = qs2.toDouble(&ok);
  qs3 = frqtv2->text();
  c = qs3.toDouble(&ok);
  a = c - b;
  qs1.sprintf("%11.0f", a);
  shifttv2->setText(qs1);
}

void avfo::displayshiftset3(QString qs){
  QString qs1, qs2, qs3;
  bool ok;
  double a, b, c;
  
  qs3 = qs;
  qs1 = shifttv3->text();
  a = qs1.toDouble(&ok); 
  qs2 = edvfoatv3->text();
  b = qs2.toDouble(&ok);
  qs3 = frqtv3->text();
  c = qs3.toDouble(&ok);
  a = c - b;
  qs1.sprintf("%11.0f", a);
  shifttv3->setText(qs1);
}

void avfo::displayshiftset4(QString qs){
  QString qs1, qs2, qs3;
  bool ok;
  double a, b, c;
  
  qs3 = qs;
  qs1 = shifttv4->text();
  a = qs1.toDouble(&ok); 
  qs2 = edvfoatv4->text();
  b = qs2.toDouble(&ok);
  qs3 = frqtv4->text();
  c = qs3.toDouble(&ok);
  a = c - b;
  qs1.sprintf("%11.0f", a);
  shifttv4->setText(qs1);
}

void avfo::displayshiftset5(QString qs){
  QString qs1, qs2, qs3;
  bool ok;
  double a, b, c;
  
  qs3 = qs;
  qs1 = shifttv5->text();
  a = qs1.toDouble(&ok); 
  qs2 = edvfoatv5->text();
  b = qs2.toDouble(&ok);
  qs3 = frqtv5->text();
  c = qs3.toDouble(&ok);
  a = c - b;
  qs1.sprintf("%11.0f", a);
  shifttv5->setText(qs1);
}

void avfo::createActions()
{
      exitAct = new QAction(QIcon(":/beenden.xpm"),tr("&Beenden"), this);
      exitAct->setStatusTip(tr("Programm beenden"));
      connect(exitAct, SIGNAL(triggered()), this, SLOT(close()));

      openAct = new QAction(tr("&Datei oeffnen"), this);
      openAct->setStatusTip(tr("Lesen der Daten von einer Datei"));
      connect(openAct, SIGNAL(triggered()), this, SLOT(open()));

      saveAct = new QAction(tr("&Datei speichern"), this);
      saveAct->setStatusTip(tr("Speichern der Daten in eine Datei"));
      connect(saveAct, SIGNAL(triggered()), this, SLOT(save()));

      piclesenAct = new QAction(tr("&Lesen vom PIC"), this);
      piclesenAct->setStatusTip(tr("Lesen der Daten vom PIC"));
      connect(piclesenAct, SIGNAL(triggered()), this, SLOT(pic2pc()));

      picschreibenAct = new QAction(tr("&Schreiben zum PIC"), this);
      picschreibenAct->setStatusTip(tr("Schreiben der Daten zum PIC"));
      connect(picschreibenAct, SIGNAL(triggered()), this, SLOT(pc2pic()));
      
      rs232Act = new QAction(tr("&RS232 einstellen"), this);
      rs232Act->setStatusTip(tr("Serielle Schnittstelle einstellen"));
      connect(rs232Act, SIGNAL(triggered()), this, SLOT(rs232einstellen()));

      bandmodeAct = new QAction(tr("Band / Modeumschaltung testen"), this);
      bandmodeAct->setStatusTip(tr("Testprogramm fuer Band und Modeumschaltung"));
      connect(bandmodeAct, SIGNAL(triggered()), this, SLOT(bandmodeslot()));
      
      aboutAct = new QAction(tr("&Ueber"), this);
      aboutAct->setStatusTip(tr("Ueber die Applikation"));
      connect(aboutAct, SIGNAL(triggered()), this, SLOT(about()));

      aboutQtAct = new QAction(tr("Ueber &Qt"), this);
      aboutQtAct->setStatusTip(tr("Show the Qt library's About box"));
      connect(aboutQtAct, SIGNAL(triggered()), qApp, SLOT(aboutQt()));
}

void avfo::createMenus()
{
      fileMenu = menuBar()->addMenu(tr("&Datei"));
      fileMenu->addAction(openAct);
      fileMenu->addAction(saveAct);
      saveAct->setEnabled(FALSE);
      fileMenu->addSeparator();
      fileMenu->addAction(exitAct);

      vfoMenu = menuBar()->addMenu(tr("&PIC-VFO"));
      vfoMenu->addAction(piclesenAct);
      vfoMenu->addAction(picschreibenAct);
      picschreibenAct->setEnabled(FALSE);
      vfoMenu->addSeparator();
      vfoMenu->addAction(rs232Act);
      vfoMenu->addSeparator();
      vfoMenu->addAction(bandmodeAct);

      menuBar()->addSeparator();

      helpMenu = menuBar()->addMenu(tr("&Hilfe"));
      helpMenu->addAction(aboutAct);
      helpMenu->addAction(aboutQtAct);
}

void avfo::createToolBars()
{
      fileToolBar = addToolBar(tr("File"));
      fileToolBar->addAction(exitAct);

}

void avfo::createStatusBar()
{
      statusBar()->showMessage(tr("Ready"));
}

void avfo::readSettings()
{
  QSettings settings("AFU", "Allbandvfo");
  QPoint pos = settings.value("pos", QPoint(200, 200)).toPoint();
  QSize size = settings.value("size", QSize(400, 400)).toSize();
  resize(size);
  move(pos);
#ifdef Q_WS_WIN
  srs232 = settings.value("rs232", QString("COM1")).toString();
#else
  srs232 = settings.value("rs232", QString("/dev/ttyS0")).toString();
#endif
  
  rs232isopen = picmodem->opentty(srs232);
  if(!rs232isopen){
    QMessageBox::about(this, tr("RS232"),tr("Die RS232 ist nicht offen!"));
  }

}

void avfo::writeSettings()
{
  QSettings settings("AFU", "Allbandvfo");
  settings.setValue("pos", pos());
  settings.setValue("size", size());
  settings.setValue("rs232", srs232);
}


avfo::~avfo()
{

}

void avfo::pc2pic(){
  QString qs, qs1, zeile;
  
  picpd->setLabelText("Daten vom PC in den PIC scheiben");
  QString beschr(tr("<b>Ablauf Daten Lesen</b><br>"
                    "1. SETUP aktivieren Menu 4 mittlere Taste <br>"
                    "2. SETUP-Punkt \"24 PC -> PIC RX\" einstellen <br>"
                    "3. SET druecken <br>"
                    "4. OK am PIC druecken. Der PIC wartet auf Daten <br>"
                    "5. OK am PC druecken"
                    ));
  if(!rs232isopen){
    QMessageBox::about(this, tr("RS232"),tr("Die RS232 ist nicht offen!"));
  }else{
    QMessageBox::about(this, tr("Daten vom PC zum PIC","InformationsBox pc2pic"), beschr);
    getDaten();
    eecounter = 0;
    timertest->stop();
    pc2pictimer->start(10);
    picpd->setValue(1);
  }
}

void avfo::pic2pc(){
  QString qs, qs1, zeile;
  
  picpd->setLabelText("Daten vom PIC lesen");
  QString beschr(tr("<b>Ablauf Daten Lesen</b><br>"
                    "1. SETUP aktivieren Menu 4 mittlere Taste <br>"
                    "2. SETUP-Punkt \"23 PIC -> PC TX\" einstellen <br>"
                    "3. SET druecken <br>"
                    "4. OK am PC druecken. Der PC wartet auf Daten <br>"
                    "5. OK am PIC druecken"));
  if(!rs232isopen){
    QMessageBox::about(this, tr("RS232"),tr("Die RS232 ist nicht offen!"));
  }else{
    defaultlesenrtty();
    QMessageBox::about(this, tr("Daten vom PIC lesen","InformationsBox pic2pc"), beschr);
    eecounter = 0;
    timertest->stop();
    pic2pctimer->start(0);
    picpd->setValue(1);
  }
}

void avfo::defaultlesenrtty(){
  char abuffer[256];
  int a = 0;

  if (rs232isopen){
    a = picmodem->readttybuffer(abuffer, 256);
  }
}

void avfo::setdauerlicht(int i)
{
  if(i == Qt::Checked)autolicht->setCheckState(Qt::Unchecked);
}

void avfo::setautolicht(int i)
{
  if(i == Qt::Checked)dauerlicht->setCheckState(Qt::Unchecked);
}

void avfo::bandmodeslot()
{
  dlg->show();
  timertest->start(10);
  befehlsindex = 0;
}

void avfo::timerteststop()
{
  int befehl;
  int befehlnr;
  int a=0;
  int i=0, j=0;
  char buffer[2];
  
  if (rs232isopen){
    a = picmodem->readttybuffer(buffer, 2);
  }
  //if(a > 0)qDebug("RX %i",a);
  if((a > 0) and (a < 3)){
    for(i=befehlsindex,j=0; j<a; i++,j++){
      befehlsbuffer[i] = buffer[j];
    }
    befehlsindex = befehlsindex + a;
  }
  if(befehlsindex == 2){
    
    befehl = int (befehlsbuffer[0]);
    befehlnr = int (befehlsbuffer[1]);
    //qDebug("0 %x",befehl);
    //qDebug("1 %x",befehlnr);
    if(befehl == 0x80){
      dlg->setband(befehlnr);
      //qDebug("BandSet %i",befehlnr);
    }
    if(befehl == 0x81){
      dlg->setmode(befehlnr);
      //qDebug("ModeSet %i",befehlnr);
    }
    befehlsindex = 0;
  }
  timertest->start(10);
}

