/***************************************************************************
 *   Copyright (C) 2009 by Andreas Lindenau   *
 *   DL4JAL@darc.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef AVFO_H
#define AVFO_H

#include <QMainWindow>
#include <QCloseEvent>
#include <QLineEdit>
#include <QLabel>
#include <QCheckBox>
#include <QGroupBox>
#include <QRadioButton>
#include <QProgressDialog>
#include <QSpinBox>

#ifdef Q_WS_WIN
#include "win_modem.h"
#else
#include "lin_modem.h"
#endif

#include "bandmode.h"

class QAction;
class QMenu;
class QTabWidget;
class QWidget;


class avfo:public QMainWindow
{
      Q_OBJECT

public:
  avfo();
  ~avfo();

protected:
  void closeEvent(QCloseEvent *event);

private slots:
  void about();
  void pic2pc();
  void pc2pic();
  void pic2pctimerstop();
  void pc2pictimerstop();
  void timerteststop();
  void picpdcancel();
  void open();
  void save();
  void rs232einstellen();
  void setAText(QString);
  void setdauerlicht(int);
  void setautolicht(int);
  void bandmodeslot();

  void displayshiftset1(QString);
  void displayshiftset2(QString);
  void displayshiftset3(QString);
  void displayshiftset4(QString);
  void displayshiftset5(QString);
  
private:
  void createActions();
  void createMenus();
  void createToolBars();
  void createStatusBar();
  void readSettings();
  void writeSettings();
  void defaultlesenrtty();
  void setDaten();
  void getDaten();
  
  int  eecounter;
  unsigned char eeprombuffer[256];
  unsigned char buffercopy[256];
  unsigned char befehlsbuffer[2];
  int befehlsindex;
  unsigned char eversion;
  QString version, verdatum;
  
  QTimer *pic2pctimer;
  QTimer *pc2pictimer;
  QTimer *timertest;
  QProgressDialog *picpd;
  QTabWidget *awidget;

  QWidget *grunddaten;
  QGroupBox *dds;
  QLineEdit *edddstakt;
  QLabel *labelddstakt;
  QRadioButton *ad9833;
  QRadioButton *ad9850;
  QRadioButton *ad9851;
  QRadioButton *ad9951_1;
  QRadioButton *ad9951_2;
  QRadioButton *ad9951_3;
  QRadioButton *ad9951_4;
  QGroupBox *zf;
  QLineEdit *zfcw;
  QLabel *labelzfcw;
  QLineEdit *zfcwr;
  QLabel *labelzfcwr;
  QLineEdit *zflsb;
  QLabel *labelzflsb;
  QLineEdit *zfusb;
  QLabel *labelzfusb;
  QLineEdit *zfdig;
  QLabel *labelzfdig;
  QLineEdit *zfdigr;
  QLabel *labelzfdigr;
  QLabel *smx;
  QLabel *smy;
  QLabel *labelsmx;
  QLabel *labelsmy;
  QLineEdit *mton;
  QLabel *labelmton;
  QSpinBox *txhang;
  QLabel *labeltxhang;
  QGroupBox *diverses;
  QCheckBox *c1hz;
  QCheckBox *dauerlicht;
  QCheckBox *autolicht;
  QCheckBox *smeter;
  QCheckBox *keyer;
  QCheckBox *sendenohnezf;
  QCheckBox *bandmodeum;
  QCheckBox *vfox4;
  QCheckBox *autostep;
  QGroupBox *geeversion;
  QRadioButton *version100;
  QRadioButton *version101;

  
  QWidget *fmess;
  QGroupBox *vfomess;
  QLineEdit *edvfoamess;
  QLineEdit *edvfobmess;
  QLabel *labelvfoamess;
  QLabel *labelvfobmess;
  
  QWidget *f160m;
  QGroupBox *vfo160m;
  QLineEdit *edvfoa160m;
  QLineEdit *edvfob160m;
  QLabel *labelvfoa160m;
  QLabel *labelvfob160m;
  QCheckBox *mzf160m;
  QGroupBox *gmodea160m;
  QRadioButton *cwa160m;
  QRadioButton *cwra160m;
  QRadioButton *usba160m;
  QRadioButton *lsba160m;
  QRadioButton *diga160m;
  QRadioButton *digra160m;
  QGroupBox *gmodeb160m;
  QRadioButton *cwb160m;
  QRadioButton *cwrb160m;
  QRadioButton *usbb160m;
  QRadioButton *lsbb160m;
  QRadioButton *digb160m;
  QRadioButton *digrb160m;
  
  QWidget *f80m;
  QGroupBox *vfo80m;
  QLineEdit *edvfoa80m;
  QLineEdit *edvfob80m;
  QLabel *labelvfoa80m;
  QLabel *labelvfob80m;
  QCheckBox *mzf80m;
  QGroupBox *gmodea80m;
  QRadioButton *cwa80m;
  QRadioButton *cwra80m;
  QRadioButton *usba80m;
  QRadioButton *lsba80m;
  QRadioButton *diga80m;
  QRadioButton *digra80m;
  QGroupBox *gmodeb80m;
  QRadioButton *cwb80m;
  QRadioButton *cwrb80m;
  QRadioButton *usbb80m;
  QRadioButton *lsbb80m;
  QRadioButton *digb80m;
  QRadioButton *digrb80m;
  
  QWidget *f60m;
  QGroupBox *vfo60m;
  QLineEdit *edvfoa60m;
  QLineEdit *edvfob60m;
  QLabel *labelvfoa60m;
  QLabel *labelvfob60m;
  QCheckBox *mzf60m;
  QGroupBox *gmodea60m;
  QRadioButton *cwa60m;
  QRadioButton *cwra60m;
  QRadioButton *usba60m;
  QRadioButton *lsba60m;
  QRadioButton *diga60m;
  QRadioButton *digra60m;
  QGroupBox *gmodeb60m;
  QRadioButton *cwb60m;
  QRadioButton *cwrb60m;
  QRadioButton *usbb60m;
  QRadioButton *lsbb60m;
  QRadioButton *digb60m;
  QRadioButton *digrb60m;
  
  QWidget *f40m;
  QGroupBox *vfo40m;
  QLineEdit *edvfoa40m;
  QLineEdit *edvfob40m;
  QLabel *labelvfoa40m;
  QLabel *labelvfob40m;
  QCheckBox *mzf40m;
  QGroupBox *gmodea40m;
  QRadioButton *cwa40m;
  QRadioButton *cwra40m;
  QRadioButton *usba40m;
  QRadioButton *lsba40m;
  QRadioButton *diga40m;
  QRadioButton *digra40m;
  QGroupBox *gmodeb40m;
  QRadioButton *cwb40m;
  QRadioButton *cwrb40m;
  QRadioButton *usbb40m;
  QRadioButton *lsbb40m;
  QRadioButton *digb40m;
  QRadioButton *digrb40m;
  
  QWidget *f30m;
  QGroupBox *vfo30m;
  QLineEdit *edvfoa30m;
  QLineEdit *edvfob30m;
  QLabel *labelvfoa30m;
  QLabel *labelvfob30m;
  QCheckBox *mzf30m;
  QGroupBox *gmodea30m;
  QRadioButton *cwa30m;
  QRadioButton *cwra30m;
  QRadioButton *usba30m;
  QRadioButton *lsba30m;
  QRadioButton *diga30m;
  QRadioButton *digra30m;
  QGroupBox *gmodeb30m;
  QRadioButton *cwb30m;
  QRadioButton *cwrb30m;
  QRadioButton *usbb30m;
  QRadioButton *lsbb30m;
  QRadioButton *digb30m;
  QRadioButton *digrb30m;
  
  QWidget *f20m;
  QGroupBox *vfo20m;
  QLineEdit *edvfoa20m;
  QLineEdit *edvfob20m;
  QLabel *labelvfoa20m;
  QLabel *labelvfob20m;
  QCheckBox *mzf20m;
  QGroupBox *gmodea20m;
  QRadioButton *cwa20m;
  QRadioButton *cwra20m;
  QRadioButton *usba20m;
  QRadioButton *lsba20m;
  QRadioButton *diga20m;
  QRadioButton *digra20m;
  QGroupBox *gmodeb20m;
  QRadioButton *cwb20m;
  QRadioButton *cwrb20m;
  QRadioButton *usbb20m;
  QRadioButton *lsbb20m;
  QRadioButton *digb20m;
  QRadioButton *digrb20m;
  
  QWidget *f17m;
  QGroupBox *vfo17m;
  QLineEdit *edvfoa17m;
  QLineEdit *edvfob17m;
  QLabel *labelvfoa17m;
  QLabel *labelvfob17m;
  QCheckBox *mzf17m;
  QGroupBox *gmodea17m;
  QRadioButton *cwa17m;
  QRadioButton *cwra17m;
  QRadioButton *usba17m;
  QRadioButton *lsba17m;
  QRadioButton *diga17m;
  QRadioButton *digra17m;
  QGroupBox *gmodeb17m;
  QRadioButton *cwb17m;
  QRadioButton *cwrb17m;
  QRadioButton *usbb17m;
  QRadioButton *lsbb17m;
  QRadioButton *digb17m;
  QRadioButton *digrb17m;
  
  QWidget *f15m;
  QGroupBox *vfo15m;
  QLineEdit *edvfoa15m;
  QLineEdit *edvfob15m;
  QLabel *labelvfoa15m;
  QLabel *labelvfob15m;
  QCheckBox *mzf15m;
  QGroupBox *gmodea15m;
  QRadioButton *cwa15m;
  QRadioButton *cwra15m;
  QRadioButton *usba15m;
  QRadioButton *lsba15m;
  QRadioButton *diga15m;
  QRadioButton *digra15m;
  QGroupBox *gmodeb15m;
  QRadioButton *cwb15m;
  QRadioButton *cwrb15m;
  QRadioButton *usbb15m;
  QRadioButton *lsbb15m;
  QRadioButton *digb15m;
  QRadioButton *digrb15m;
  
  QWidget *f12m;
  QGroupBox *vfo12m;
  QLineEdit *edvfoa12m;
  QLineEdit *edvfob12m;
  QLabel *labelvfoa12m;
  QLabel *labelvfob12m;
  QCheckBox *mzf12m;
  QGroupBox *gmodea12m;
  QRadioButton *cwa12m;
  QRadioButton *cwra12m;
  QRadioButton *usba12m;
  QRadioButton *lsba12m;
  QRadioButton *diga12m;
  QRadioButton *digra12m;
  QGroupBox *gmodeb12m;
  QRadioButton *cwb12m;
  QRadioButton *cwrb12m;
  QRadioButton *usbb12m;
  QRadioButton *lsbb12m;
  QRadioButton *digb12m;
  QRadioButton *digrb12m;
  
  QWidget *f10m;
  QGroupBox *vfo10m;
  QLineEdit *edvfoa10m;
  QLineEdit *edvfob10m;
  QLabel *labelvfoa10m;
  QLabel *labelvfob10m;
  QCheckBox *mzf10m;
  QGroupBox *gmodea10m;
  QRadioButton *cwa10m;
  QRadioButton *cwra10m;
  QRadioButton *usba10m;
  QRadioButton *lsba10m;
  QRadioButton *diga10m;
  QRadioButton *digra10m;
  QGroupBox *gmodeb10m;
  QRadioButton *cwb10m;
  QRadioButton *cwrb10m;
  QRadioButton *usbb10m;
  QRadioButton *lsbb10m;
  QRadioButton *digb10m;
  QRadioButton *digrb10m;
  
  QWidget *f6m;
  QGroupBox *vfo6m;
  QLineEdit *edvfoa6m;
  QLineEdit *edvfob6m;
  QLabel *labelvfoa6m;
  QLabel *labelvfob6m;
  QCheckBox *mzf6m;
  QGroupBox *gmodea6m;
  QRadioButton *cwa6m;
  QRadioButton *cwra6m;
  QRadioButton *usba6m;
  QRadioButton *lsba6m;
  QRadioButton *diga6m;
  QRadioButton *digra6m;
  QGroupBox *gmodeb6m;
  QRadioButton *cwb6m;
  QRadioButton *cwrb6m;
  QRadioButton *usbb6m;
  QRadioButton *lsbb6m;
  QRadioButton *digb6m;
  QRadioButton *digrb6m;
  
  QWidget *f2m;
  QGroupBox *vfo2m;
  QLineEdit *edvfoa2m;
  QLineEdit *edvfob2m;
  QLabel *labelvfoa2m;
  QLabel *labelvfob2m;
  QCheckBox *mzf2m;
  QGroupBox *gmodea2m;
  QRadioButton *cwa2m;
  QRadioButton *cwra2m;
  QRadioButton *usba2m;
  QRadioButton *lsba2m;
  QRadioButton *diga2m;
  QRadioButton *digra2m;
  QGroupBox *gmodeb2m;
  QRadioButton *cwb2m;
  QRadioButton *cwrb2m;
  QRadioButton *usbb2m;
  QRadioButton *lsbb2m;
  QRadioButton *digb2m;
  QRadioButton *digrb2m;
  
  QWidget *tv1;
  QGroupBox *vfotv1;
  QLineEdit *edvfoatv1;
  QLineEdit *edvfobtv1;
  QLabel *labelvfoatv1;
  QLabel *labelvfobtv1;
  QCheckBox *mzftv1;
  QGroupBox *gmodeatv1;
  QRadioButton *cwatv1;
  QRadioButton *cwratv1;
  QRadioButton *usbatv1;
  QRadioButton *lsbatv1;
  QRadioButton *digatv1;
  QRadioButton *digratv1;
  QGroupBox *gmodebtv1;
  QRadioButton *cwbtv1;
  QRadioButton *cwrbtv1;
  QRadioButton *usbbtv1;
  QRadioButton *lsbbtv1;
  QRadioButton *digbtv1;
  QRadioButton *digrbtv1;
  QGroupBox *displaytv1;
  QLineEdit *frqtv1;
  QLabel *labelfrqtv1;
  QLabel *shifttv1;
  QLabel *labelshifttv1;
  
  QWidget *tv2;
  QGroupBox *vfotv2;
  QLineEdit *edvfoatv2;
  QLineEdit *edvfobtv2;
  QLabel *labelvfoatv2;
  QLabel *labelvfobtv2;
  QCheckBox *mzftv2;
  QGroupBox *gmodeatv2;
  QRadioButton *cwatv2;
  QRadioButton *cwratv2;
  QRadioButton *usbatv2;
  QRadioButton *lsbatv2;
  QRadioButton *digatv2;
  QRadioButton *digratv2;
  QGroupBox *gmodebtv2;
  QRadioButton *cwbtv2;
  QRadioButton *cwrbtv2;
  QRadioButton *usbbtv2;
  QRadioButton *lsbbtv2;
  QRadioButton *digbtv2;
  QRadioButton *digrbtv2;
  QGroupBox *displaytv2;
  QLineEdit *frqtv2;
  QLabel *labelfrqtv2;
  QLabel *shifttv2;
  QLabel *labelshifttv2;
  
  QWidget *tv3;
  QGroupBox *vfotv3;
  QLineEdit *edvfoatv3;
  QLineEdit *edvfobtv3;
  QLabel *labelvfoatv3;
  QLabel *labelvfobtv3;
  QCheckBox *mzftv3;
  QGroupBox *gmodeatv3;
  QRadioButton *cwatv3;
  QRadioButton *cwratv3;
  QRadioButton *usbatv3;
  QRadioButton *lsbatv3;
  QRadioButton *digatv3;
  QRadioButton *digratv3;
  QGroupBox *gmodebtv3;
  QRadioButton *cwbtv3;
  QRadioButton *cwrbtv3;
  QRadioButton *usbbtv3;
  QRadioButton *lsbbtv3;
  QRadioButton *digbtv3;
  QRadioButton *digrbtv3;
  QGroupBox *displaytv3;
  QLineEdit *frqtv3;
  QLabel *labelfrqtv3;
  QLabel *shifttv3;
  QLabel *labelshifttv3;
  
  QWidget *tv4;
  QGroupBox *vfotv4;
  QLineEdit *edvfoatv4;
  QLineEdit *edvfobtv4;
  QLabel *labelvfoatv4;
  QLabel *labelvfobtv4;
  QCheckBox *mzftv4;
  QGroupBox *gmodeatv4;
  QRadioButton *cwatv4;
  QRadioButton *cwratv4;
  QRadioButton *usbatv4;
  QRadioButton *lsbatv4;
  QRadioButton *digatv4;
  QRadioButton *digratv4;
  QGroupBox *gmodebtv4;
  QRadioButton *cwbtv4;
  QRadioButton *cwrbtv4;
  QRadioButton *usbbtv4;
  QRadioButton *lsbbtv4;
  QRadioButton *digbtv4;
  QRadioButton *digrbtv4;
  QGroupBox *displaytv4;
  QLineEdit *frqtv4;
  QLabel *labelfrqtv4;
  QLabel *shifttv4;
  QLabel *labelshifttv4;
  
  QWidget *tv5;
  QGroupBox *vfotv5;
  QLineEdit *edvfoatv5;
  QLineEdit *edvfobtv5;
  QLabel *labelvfoatv5;
  QLabel *labelvfobtv5;
  QCheckBox *mzftv5;
  QGroupBox *gmodeatv5;
  QRadioButton *cwatv5;
  QRadioButton *cwratv5;
  QRadioButton *usbatv5;
  QRadioButton *lsbatv5;
  QRadioButton *digatv5;
  QRadioButton *digratv5;
  QGroupBox *gmodebtv5;
  QRadioButton *cwbtv5;
  QRadioButton *cwrbtv5;
  QRadioButton *usbbtv5;
  QRadioButton *lsbbtv5;
  QRadioButton *digbtv5;
  QRadioButton *digrbtv5;
  QGroupBox *displaytv5;
  QLineEdit *frqtv5;
  QLabel *labelfrqtv5;
  QLabel *shifttv5;
  QLabel *labelshifttv5;
  
  QMenu *fileMenu;
  QMenu *vfoMenu;
  QMenu *helpMenu;
  QToolBar *fileToolBar;
  QAction *exitAct;
  QAction *openAct;
  QAction *saveAct;
  QAction *aboutAct;
  QAction *aboutQtAct;
  QAction *piclesenAct;
  QAction *picschreibenAct;
  QAction *rs232Act;
  QAction *bandmodeAct;
  
  Modem *picmodem;
  QString srs232;
  bool rs232isopen;

  bandmodedlg *dlg;
};

#endif
