//
// C++ Implementation: optiondlg
//
// Description: 
//
//
// Author: Andreas Lindenau <DL4JAL@darc.de>, (C) 2005
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include <qdialog.h>
#include <QString>

#include "bandmode.h"

bandmodedlg::bandmodedlg(QWidget* parent): QDialog(parent)
{
  
  this->resize(330,350);
  this->setMinimumSize(0,0);
  this->setModal(TRUE);
  
  this->setWindowTitle(tr("Band- / Modeumschaltung"));
  close = new QPushButton("Schliessen", this);
  close->setGeometry(20,310,100,30);
  connect(close, SIGNAL(clicked()), SLOT(hideslot()));
  
  boxmess = new QCheckBox(this);
  boxmess->setText("Messender");
  box160m = new QCheckBox(this);
  box160m->setText("160m");
  box80m = new QCheckBox(this);
  box80m->setText("80m");
  box60m = new QCheckBox(this);
  box60m->setText("60m");
  box40m = new QCheckBox(this);
  box40m->setText("40m");
  box30m = new QCheckBox(this);
  box30m->setText("30m");
  box20m = new QCheckBox(this);
  box20m->setText("20m");
  box17m = new QCheckBox(this);
  box17m->setText("17m");
  box15m = new QCheckBox(this);
  box15m->setText("15m");
  box12m = new QCheckBox(this);
  box12m->setText("12m");
  box10m = new QCheckBox(this);
  box10m->setText("10m");
  box6m = new QCheckBox(this);
  box6m->setText("6m");
  box2m = new QCheckBox(this);
  box2m->setText("2m");
  boxtv1 = new QCheckBox(this);
  boxtv1->setText("Trv. 1");
  boxtv2 = new QCheckBox(this);
  boxtv2->setText("Trv. 2");
  boxtv3 = new QCheckBox(this);
  boxtv3->setText("Trv. 3");
  boxtv4 = new QCheckBox(this);
  boxtv4->setText("Trv. 4");
  boxtv5 = new QCheckBox(this);
  boxtv5->setText("Trv. 5");
  boxcw = new QCheckBox(this);
  boxcw->setText("CW");
  boxlsb = new QCheckBox(this);
  boxlsb->setText("LSB");
  boxusb = new QCheckBox(this);
  boxusb->setText("USB");
  boxcwr = new QCheckBox(this);
  boxcwr->setText("CW revers");
  boxdig = new QCheckBox(this);
  boxdig->setText("DIG");
  boxdigr = new QCheckBox(this);
  boxdigr->setText("DIG revers");
  
  int i=0;
  boxmess->setGeometry(10,10,100,25);
  i++;
  box160m->setGeometry(10,10+30*i,100,25);
  i++;
  box80m->setGeometry(10,10+30*i,100,25);
  i++;
  box60m->setGeometry(10,10+30*i,100,25);
  i++;
  box40m->setGeometry(10,10+30*i,100,25);
  i++;
  box30m->setGeometry(10,10+30*i,100,25);
  i++;
  box20m->setGeometry(10,10+30*i,100,25);
  i++;
  box17m->setGeometry(10,10+30*i,100,25);
  i++;
  box15m->setGeometry(10,10+30*i,100,25);
  i=0;
  box12m->setGeometry(110,10+30*i,100,25);
  i++;
  box10m->setGeometry(110,10+30*i,100,25);
  i++;
  box6m->setGeometry(110,10+30*i,100,25);
  i++;
  box2m->setGeometry(110,10+30*i,100,25);
  i++;
  boxtv1->setGeometry(110,10+30*i,100,25);
  i++;
  boxtv2->setGeometry(110,10+30*i,100,25);
  i++;
  boxtv3->setGeometry(110,10+30*i,100,25);
  i++;
  boxtv4->setGeometry(110,10+30*i,100,25);
  i++;
  boxtv5->setGeometry(110,10+30*i,100,25);
  i=0;
  boxcw->setGeometry(220,10+30*i,100,25);
  i++;
  boxlsb->setGeometry(220,10+30*i,100,25);
  i++;
  boxusb->setGeometry(220,10+30*i,100,25);
  i++;
  boxcwr->setGeometry(220,10+30*i,100,25);
  i++;
  boxdig->setGeometry(220,10+30*i,100,25);
  i++;
  boxdigr->setGeometry(220,10+30*i,100,25);

};

void bandmodedlg::hideslot()
{
  this->hide();
}

void bandmodedlg::setband(int a)
{
  bandallesaus();
  switch(a){
    case 0:boxmess->setChecked(TRUE);break;
    case 1:box160m->setChecked(TRUE);break;
    case 2:box80m->setChecked(TRUE);break;
    case 3:box60m->setChecked(TRUE);break;
    case 4:box40m->setChecked(TRUE);break;
    case 5:box30m->setChecked(TRUE);break;
    case 6:box20m->setChecked(TRUE);break;
    case 7:box17m->setChecked(TRUE);break;
    case 8:box15m->setChecked(TRUE);break;
    case 9:box12m->setChecked(TRUE);break;
    case 10:box10m->setChecked(TRUE);break;
    case 11:box6m->setChecked(TRUE);break;
    case 12:box2m->setChecked(TRUE);break;
    case 13:boxtv1->setChecked(TRUE);break;
    case 14:boxtv2->setChecked(TRUE);break;
    case 15:boxtv3->setChecked(TRUE);break;
    case 16:boxtv4->setChecked(TRUE);break;
    case 17:boxtv5->setChecked(TRUE);break;
  }
}

void bandmodedlg::setmode(int a)
{
  modeallesaus();
  switch(a){
    case 1:boxcw->setChecked(TRUE);break;
    case 2:boxcwr->setChecked(TRUE);break;
    case 3:boxlsb->setChecked(TRUE);break;
    case 4:boxusb->setChecked(TRUE);break;
    case 5:boxdig->setChecked(TRUE);break;
    case 6:boxdigr->setChecked(TRUE);break;
  }
}

void bandmodedlg::modeallesaus()
{
  boxcw->setChecked(FALSE);
  boxlsb->setChecked(FALSE);
  boxusb->setChecked(FALSE);
  boxcwr->setChecked(FALSE);
  boxdig->setChecked(FALSE);
  boxdigr->setChecked(FALSE);
}

void bandmodedlg::bandallesaus()
{
  boxmess->setChecked(FALSE);
  box160m->setChecked(FALSE);
  box80m->setChecked(FALSE);
  box60m->setChecked(FALSE);
  box40m->setChecked(FALSE);
  box30m->setChecked(FALSE);
  box20m->setChecked(FALSE);
  box17m->setChecked(FALSE);
  box15m->setChecked(FALSE);
  box12m->setChecked(FALSE);
  box10m->setChecked(FALSE);
  box6m->setChecked(FALSE);
  box2m->setChecked(FALSE);
  boxtv1->setChecked(FALSE);
  boxtv2->setChecked(FALSE);
  boxtv3->setChecked(FALSE);
  boxtv4->setChecked(FALSE);
  boxtv5->setChecked(FALSE);
}

